/*****************************************************************************
*
* Atmel Corporation
*
* File              : USI_TWI_Slave.h
* Compiler          : IAR EWAAVR 2.28a/3.10a
* Revision          : $Revision: 1.7 $
* Date              : $Date: 26. mai 2004 11:35:34 $
* Updated by        : $Author: ltwa $
*
* Support mail      : avr@atmel.com
*
* Supported devices : All device with USI module can be used.
*                     The example is written for the ATmega169, ATtiny26 & 
*                     ATtiny2313
*
* AppNote           : AVR312 - Using the USI module as a TWI slave
*
* Description       : Header file for USI_TWI driver
*
****************************************************************************/

// Defines controlling code generation
//   What is buffer_control?
//#define BUFFER_CONTROL

#define TWI_RX_BUFFER_SIZE 6     
#define TWI_TX_BUFFER_SIZE 6

#define TRUE                1
#define FALSE               0


//********** USI_TWI Prototypes **********//

void          TWI_Slave_Initialise(unsigned char);
unsigned char TWI_Start_Transceiver_With_Data(unsigned char *,
		 	  									  unsigned char );
unsigned char TWI_Get_Data_From_Transceiver(unsigned char *,
		 	  									unsigned char );

#define DDR_USI             DDRB
#define PORT_USI            PORTB
#define PIN_USI             PINB
#define PORT_USI_SDA        PORTB0
#define PORT_USI_SCL        PORTB2
#define PIN_USI_SDA         PINB0
#define PIN_USI_SCL         PINB2

//********** Global Variables **********//

struct TWI_S_statusReg {
    unsigned dataInTxBuf:1;
    unsigned dataInRxBuf:1;
    unsigned genAddressCall:1; // TRUE = General call, FALSE = TWI Address;
    unsigned RxBufOverflow:1;
    unsigned TxBufOverflow:1;
    unsigned unused:3;
    } ;

struct TWI_S_statusReg TWI_statusReg ;

