	.module SmartLCD_Controller.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
	.area lit(rom, con, rel)
_signon1::
	.byte 10,13,10,13,'S,'m,'a,'r,'t,'L,'C,'D,32,'C,'o,'n
	.byte 't,'r,'o,'l,'l,'e,'r,32,'V,48,46,56,57,10,13,0
	.dbsym e signon1 _signon1 A[32:32]kc
_signon11::
	.byte 40,'c,41,32,'C,'o,'p,'y,'r,'i,'g,'h,'t,32,'S,'O
	.byte 'C,32,'R,'o,'b,'o,'t,'i,'c,'s,44,32,'I,'n,'c,46
	.byte 10,13,0
	.dbsym e signon11 _signon11 A[35:35]kc
_signon12::
	.byte 'S,'e,'n,'d,'i,'n,'g,32,'E,'S,'C,32,'c,32,'t,'u
	.byte 'r,'n,'s,32,'c,'h,'a,'r,'a,'c,'t,'e,'r,32,'d,'i
	.byte 's,'p,'l,'a,'y,32,'o,'n,10,13,10,13,0
	.dbsym e signon12 _signon12 A[45:45]kc
_line1chars::
	.byte 'S,'m
	.byte 'a,'r
	.byte 't,'L
	.byte 'C,'D
	.byte 32,32
	.byte 32,32
	.byte 0
	.dbsym e line1chars _line1chars A[13:13]kc
_line2chars::
	.byte 'V,'e
	.byte 'r,'s
	.byte 'i,'o
	.byte 'n,32
	.byte 48,46
	.byte 56,57
	.byte 0
	.dbsym e line2chars _line2chars A[13:13]kc
_line3chars::
	.byte 'S,'O
	.byte 'C,32
	.byte 'R,'o
	.byte 'b,'o
	.byte 't,'i
	.byte 'c,'s
	.byte 0
	.dbsym e line3chars _line3chars A[13:13]kc
_line4chars::
	.byte 'U,'a
	.byte 'r,'t
	.byte 32,'I
	.byte 50,'C
	.byte 32,'O
	.byte 'n,32
	.byte 0
	.dbsym e line4chars _line4chars A[13:13]kc
_line11chars::
	.byte 'U,'a
	.byte 'r,'t
	.byte 32,49
	.byte 57,50
	.byte 48,48
	.byte 44,56
	.byte 0
	.dbsym e line11chars _line11chars A[13:13]kc
_line12chars::
	.byte 'I,50
	.byte 'C,32
	.byte 'A,'d
	.byte 'd,32
	.byte 48,'x
	.byte 32,32
	.byte 0
	.dbsym e line12chars _line12chars A[13:13]kc
_line13chars::
	.byte 'S,'e
	.byte 'n,'d
	.byte 32,'E
	.byte 'S,'C
	.byte 32,'c
	.byte 32,32
	.byte 0
	.dbsym e line13chars _line13chars A[13:13]kc
_line14chars::
	.byte 'f,'o
	.byte 'r,32
	.byte 't,'e
	.byte 'x,'t
	.byte 32,'m
	.byte 'o,'d
	.byte 0
	.dbsym e line14chars _line14chars A[13:13]kc
_line21chars::
	.byte 'T,'e
	.byte 'x,'t
	.byte 32,'D
	.byte 'i,'s
	.byte 'p,'l
	.byte 'a,'y
	.byte 0
	.dbsym e line21chars _line21chars A[13:13]kc
_line22chars::
	.byte 'a,'c
	.byte 't,'i
	.byte 'v,'a
	.byte 't,'e
	.byte 'd,32
	.byte 32,32
	.byte 0
	.dbsym e line22chars _line22chars A[13:13]kc
_line23chars::
	.byte 'P,'r
	.byte 'e,'s
	.byte 's,32
	.byte 'k,'e
	.byte 'y,32
	.byte 51,32
	.byte 0
	.dbsym e line23chars _line23chars A[13:13]kc
_line24chars::
	.byte 't,'o
	.byte 32,'e
	.byte 'x,'i
	.byte 't,32
	.byte 32,32
	.byte 32,32
	.byte 0
	.dbsym e line24chars _line24chars A[13:13]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
	.dbfunc e bytetoint _bytetoint fV
;           ones -> R20
;           tens -> R22
;           byte -> R10
	.even
_bytetoint::
	xcall push_xgsetF00C
	mov R10,R16
	.dbline -1
	.dbline 306
; /**************************************************************
; 
;    Program Title:  SmartLCD Controller
;    
;    Program Name:  SmartLCD_Controller.c	  Version: 0.89
;    
;    Author:  SS	   					  Date:  November 9, 2010
;    
;   This program monitors data on SCL/SDA or UART and writes it to the ECMA1007
;   LCD panel. A simple command structure is used to write text to the 
;   screen.  The LCD panel is addressed by comparing addresses stored 
;   in EEPROM with commands sent on the 2-Wire line.
;   
;   The SmartLCD PCB has pads for a xtal or clock osc for real time
;   clock or precision operation.
;   
;   The SmartLCD PCB also has a pad for the ST Electronics three axis 
;   programmable accelerometer.
;   
;   I2C default address is:  0x25
;   
;   Pin assignments:
;     PC4  Pin 1 - SDA
;     PC5  Pin 3 - SCL
;     PC3  Pin 20 - SCL ECMA1007 
;     PC2  Pin 11 - SI ECMA1007
;     PB1  Pin 4 - CS ECMA1007
;     PB2  Pin 8 - LA0 ECMA1007
;     PB0  Pin 7 - RESET ECMA1007
; 
;   Settings can be stored in EEPROM for later recall at power up.
; 
;   EEPROM Settings:
;      Address    Default    Function
;        0x00       0x01      Address of Controller - 1-256, 0 broadcast
;        0x05       0x00      Oscillator calibrated - 0 - No
;        0x06       0x00      Oscillator calibration value
;        0x07       0x00      
; 
;   2-Wire Commands:  Commands are sent to the display controller using
;   a TWI protocol.  Wakeup address and selection addresses are stored
;   in EEPROM and can be changed.
; 
;      Command      Function
;        DAC        display character at address A
;        DC         Display character at current cursor location
;        C          Clear screen
;        S          Scroll up one line
;        NA         New selection address
;        WA         Wakeup address
;        H          Turn IR High power on
; 
;    Fuse settings should be:  F9 DF E2
;    
;    Copyright 2004-2010, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2010, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: SmartLCD_Controller.c,v $
;  * Revision 0.89  2006/02/07 16:40:20  SS
;  *    Arduino integration, 19200baud, USART active
;  *    real time clock 
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash writer, XON/XOFF, 9,600baud
;  *    real time clock and auto-internal osc calibration.
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  * 
;  */ 
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <math.h>
; //#include <stdio.h>
; #include "SmartLCD_Uart.h"
; #include "SmartLCD_Defines.h"
; #include "SmartLCD_Extern.h"
; //#include "USI_TWI_Slave.h"
; 
; //  Variable declarations
; unsigned int intelsuperaddress,oldpage,oldbyteoffset,totalrxcnt;
; unsigned int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
; unsigned int mseccountdown1,mseccountdown2,mseccountdown3,mseccountdown4;
; unsigned int seconds,minutes,hours,days,count;
; 
; unsigned int totalbytecnt,xoncnt,xoffcnt;
; unsigned char frameerror,dataoverrun,numstrg[9],lcdchiptype;
; unsigned char lcdstate,rtcclockcnt,textdisplaymode;
; 
; extern int _textmode;
; 
; /* Static Variables */
; unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
; unsigned char UART_RxHead;
; unsigned char UART_RxTail;
; unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
; unsigned char UART_TxHead;
; unsigned char UART_TxTail;
; char  xoffsent, xonsent, enablexonoff, echoinchars,sendxoff;
; char  rxcnt,checkflag,rxcntmax,flip2;
; unsigned char  instrg[8],vlow,vhigh,hexbyte[3],lcdledpower;
; 
; unsigned char FlashAddress[3];
; const char signon1[] = "\n\r\n\rSmartLCD Controller V0.89\n\r";
; const char signon11[] = "(c) Copyright SOC Robotics, Inc.\n\r";
; const char signon12[] = "Sending ESC c turns character display on\n\r\n\r";
; 
; // Function declarations
; unsigned char EEPROMwrite(int,unsigned char);
; unsigned char EEPROMread(int);
; 
; // Sample TWI transmission commands
; #define TWI_CMD_MASTER_WRITE 0x00
; #define TWI_CMD_MASTER_READ  0x01
; 
; // TBD - how many bytes can be transmitted per 2-wire operation?
; #define MESSAGEBUF_SIZE       4
; 
; //  Set default slave address
; #define    TWI_SLAVEADDRESS		 0x26
; 
; // Clear display - move cursor to home
; #define    LCDCLR	0x01
; 
; // E1010 and E1007 Commands
; #define	   LCDCHIPE1010 0x10
; #define    LCDCHIPE1007 0x07   
; 
; // move cursor to home position command
; #define    LCDHOME   	0x10  
; 
; // Static Display Command
; //   D1/0 - 0,0  Display OFF
; //   D1/0 - 0,1  1-2Hz blink
; //   D1/0 - 1,0  3-4Hz blink
; //   D1/0 - 1,1  Display ON
; #define    LCDSTATICDISPLAY	0x20 
; #define    LCDDISPLAYON  	0x03
; #define    LCDDISPLAYOFF	0x00 
; 
; // Display control command
; //   D3-C, D2-B, D1-DC, D0-D
; //   C  -> 1 cursor on, 0 off
; //   DC -> 1 double cursor on, 0 off
; //   B  -> 1 blink on, 0 off
; //   D  -> 1 display on, 0 off	 
; #define    LCDDISPLAY          0x30 
; #define    LCDCURSORON	       0x08
; #define    LCDCURSOROFF        0x00
; #define    LCDCURSORBLINK      0x04 
; #define    LCDCURSONNOBLINK    0x00
; #define    LCDCURSORDISPLAYON  0x01
; #define    LCDCURSORDISPLAYOFF 0x00
; 
; // Power Save Command
; //   D1-O, D0-PS
; //   PS -> 1 power save on, 0 off
; //   O  -> 1 oscillator circuit on, 0 off
; #define	   LCDPOWERSAVE    0x40
; #define    LCDPOWERSAVEON  0x01
; #define    LCDPOWERSAVEOFF 0x00
; #define    LCDOSCON		   0x02
; #define    LCDOSCOFF	   0x00
; 
; // Power supply control
; //   D2-VC, D1-VF, D0-P
; //   VC -> 1 voltage regulator on, 0 off
; //   VF -> 1 voltage follower on, 0 off
; //   P  -> 1 voltage booster on, 0 off
; #define    LCDPOWERSUPPLY   0x50
; #define	   LCDVOLTREGON     0x04
; #define	   LCDVOLTREGOFF    0x00
; #define	   LCDVOLTFOLLOWON  0x02
; #define	   LCDVOLTFOLLOWOFF 0x00
; #define	   LCDVOLTBOOSTON   0x01
; #define	   LCDVOLTBOOSTOFF  0x00
; 
; // System set command
; //   D3-N2, D2-N1, D0-CG
; //   N2/1 -> 0,0  2 lines
; //   N2/1 -> 0,1  3 lines
; //   N2/1 -> 1,0  4 lines
; //   CG   -> 1 CGRAM used, 0 not used
; #define    LCDSYSTEMSET  0x60
; #define    LCD4LINE		 0x08
; #define    LCDCGON		 0x01
; 
; // Electronic volume setting
; //   D3-0 - set display brightness
; #define    LCDVOLREG 0x70  
; 
; // Set address of DDRAM, CGRAM or symbol register
; #define    LCDRAMADDRESS  0x80 
; 
; //  LCD chip select is active low
; #define	   CS       1
; //  LCD Command/Data  0 - command, 1 data
; #define    LA0      2
; //  LCD reset line - active high to reset
; #define    LCDRESET 0
; //  LCD Serial Data Line
; #define    LCD_SI   2
; //  LCD Serial Clock
; #define    LCD_SCLK 3
; 
; #define    LCDCONTROL PORTB
; #define    LCDDATA    PORTC
; #define    LINE1 	  0x30
; #define	   LINE2	  0x40
; #define	   LINE3	  0x50
; #define	   LINE4	  0x60
; 
; #define    TAB		  0x09
; #define    CRLF       0x10
; #define    TITLE      0x01
; 
; // LCD defines
; #define  LCD_BATTERY_FULL    6
; #define  LCD_BATTERY_THREEQUARTER 5 
; #define  LCD_BATTERY_HALF    4
; #define  LCD_BATTERY_QUARTER 3
; #define  LCD_BATTERY_EMPTY   2
; #define  LCD_BATTERY_OFF     1
; 
; #define  LCD_ANTENNA_FULL    6
; #define  LCD_ANTENNA_THREEQUARTER  5
; #define  LCD_ANTENNA_HALF    4
; #define  LCD_ANTENNA_QUARTER 3 
; #define  LCD_ANTENNA_EMPTY   2
; #define  LCD_ANTENNA_OFF     1
; 
; #define  LCD_PHONE_ON		 1
; #define  LCD_SLASHPHONE		 2
; #define  LCD_PHONE_OFF		 3
; 
; #define  LCD_PHONE_SYMBOL      0x02
; #define  LCD_BIGANTENNA_SYMBOL 0x08
; 
; #define  NO_ACTIVE_STATE 0
; #define  ANTENNA_STATE  1
; #define  BATTERY_STATE  2
; #define  VSYM_STATE     3
; #define  DSYM_STATE     4
; #define  RSYM_STATE     5
; #define  ENVELOPE_STATE 6
; #define  PHONE_STATE    7
; #define  TWI_ADDRESS_STATE 8
; #define  LCD_SYMBOL_STATE 9
; #define  LED_BLINK_STATE 10
; #define  VOLTAGE_STATE  11
; 
; const unsigned char line1chars[] = {'S','m','a','r','t','L','C','D',' ',' ',' ',' ',0x00};
; const unsigned char line2chars[] = {'V','e','r','s','i','o','n',' ','0','.','8','9',0x00};
; const unsigned char line3chars[] = {'S','O','C',' ','R','o','b','o','t','i','c','s',0x00};
; const unsigned char line4chars[] = {'U','a','r','t',' ','I','2','C',' ','O','n',' ',0x00};
; const unsigned char line11chars[] = {'U','a','r','t',' ','1','9','2','0','0',',','8',0x00};
; const unsigned char line12chars[] = {'I','2','C',' ','A','d','d',' ','0','x',' ',' ',0x00};
; const unsigned char line13chars[] = {'S','e','n','d',' ','E','S','C',' ','c',' ',' ',0x00};
; const unsigned char line14chars[] = {'f','o','r',' ','t','e','x','t',' ','m','o','d',0x00};
; const unsigned char line21chars[] = {'T','e','x','t',' ','D','i','s','p','l','a','y',0x00};
; const unsigned char line22chars[] = {'a','c','t','i','v','a','t','e','d',' ',' ',' ',0x00};
; const unsigned char line23chars[] = {'P','r','e','s','s',' ','k','e','y',' ','3',' ',0x00};
; const unsigned char line24chars[] = {'t','o',' ','e','x','i','t',' ',' ',' ',' ',' ',0x00};
; unsigned char line1[13],line2[13],line3[13],line4[13];
; unsigned char cursorposition,cursormax,rowptr,colptr,lineptr,escmode;
; unsigned char lcdphoneantennasymbols,lcdstate,symbolmode,voltagevolume;
; 
; extern struct TWI_S_statusReg TWI_statusReg;
; 
; void bytetoint(unsigned char byte)
; {
	.dbline 309
;  	 unsigned char tens,ones;
; 	 
; 	 tens = byte/10;
	ldi R17,10
	mov R16,R10
	xcall div8u
	mov R22,R16
	.dbline 310
; 	 ones = byte%10;
	ldi R17,10
	mov R16,R10
	xcall mod8u
	mov R20,R16
	.dbline 311
; 	 hexbyte[0] = tens + '0';
	mov R24,R22
	subi R24,208    ; addi 48
	sts _hexbyte,R24
	.dbline 312
; 	 hexbyte[1] = ones + '0';
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
	.dbline 313
; 	 hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r ones 20 c
	.dbsym r tens 22 c
	.dbsym r byte 10 c
	.dbend
	.dbfunc e LCDWriteSerialByte _LCDWriteSerialByte fV
;           mask -> R20
;              i -> R22
;         inchar -> R16
	.even
_LCDWriteSerialByte::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 317
; }
; 
; void   LCDWriteSerialByte(unsigned char inchar)
; {
	.dbline 320
;  	unsigned char i,mask;
; 
; 	mask = 0x80;
	ldi R20,128
	.dbline 321
; 	for(i=0; i<8; i++) {
	clr R22
	xjmp L8
L5:
	.dbline 321
	.dbline 322
; 	    ClrBit(LCDDATA,LCD_SCLK);
	cbi 0x8,3
	.dbline 323
; 		if((inchar&mask)) SetBit(LCDDATA,LCD_SI);
	mov R2,R16
	and R2,R20
	breq L9
X0:
	.dbline 323
	sbi 0x8,2
	xjmp L10
L9:
	.dbline 324
; 		else ClrBit(LCDDATA,LCD_SI);
	cbi 0x8,2
L10:
	.dbline 325
; 		mask >>= 1;
	lsr R20
	.dbline 326
; 		SetBit(LCDDATA,LCD_SCLK);
	sbi 0x8,3
	.dbline 327
; 	    }
L6:
	.dbline 321
	inc R22
L8:
	.dbline 321
	cpi R22,8
	brlo L5
X1:
	.dbline -2
L4:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r mask 20 c
	.dbsym r i 22 c
	.dbsym r inchar 16 c
	.dbend
	.dbfunc e LCDprintchar _LCDprintchar fV
;         inchar -> R10
	.even
_LCDprintchar::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 331
; }
; 
; void   LCDprintchar(unsigned char inchar)
; {
	.dbline 332
; 	LCDCONTROL |= BIT(LA0); // raise A0 high
	sbi 0x5,2
	.dbline 333
; 	LCDCONTROL &= ~BIT(CS); // set CS low
	cbi 0x5,1
	.dbline 334
; 	ShortDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _ShortDelay
	.dbline 335
; 	LCDWriteSerialByte(inchar);
	mov R16,R10
	xcall _LCDWriteSerialByte
	.dbline 336
; 	LCDCONTROL |= BIT(CS); // release CS
	sbi 0x5,1
	.dbline 337
; 	ShortDelay(2);	
	ldi R16,2
	ldi R17,0
	xcall _ShortDelay
	.dbline -2
L11:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e LCDwritecommand _LCDwritecommand fV
;         inchar -> R10
	.even
_LCDwritecommand::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 341
; }
; 
; void   LCDwritecommand(unsigned char inchar)
; { 		
	.dbline 342
; 	LCDCONTROL &= ~BIT(LA0); /* set A0 low */
	cbi 0x5,2
	.dbline 343
; 	LCDCONTROL &= ~BIT(CS);  /* set RS low */
	cbi 0x5,1
	.dbline 344
; 	ShortDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _ShortDelay
	.dbline 345
; 	LCDWriteSerialByte(inchar);
	mov R16,R10
	xcall _LCDWriteSerialByte
	.dbline 346
; 	LCDCONTROL |= BIT(CS); // release CS
	sbi 0x5,1
	.dbline 347
; 	ShortDelay(2);
	ldi R16,2
	ldi R17,0
	xcall _ShortDelay
	.dbline -2
L12:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e LCDDisplayChar _LCDDisplayChar fV
;         inchar -> R10
;        address -> R20
	.even
_LCDDisplayChar::
	st -y,R10
	st -y,R20
	mov R10,R18
	mov R20,R16
	.dbline -1
	.dbline 351
; }
; 
; void   LCDDisplayChar(unsigned char address, unsigned char inchar)
; {
	.dbline 352
;  	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R20
	ori R16,128
	xcall _LCDwritecommand
	.dbline 353
; 	LCDprintchar(inchar);
	mov R16,R10
	xcall _LCDprintchar
	.dbline -2
L13:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e LCD_Write _LCD_Write fV
;           data -> R10
;        address -> R20
	.even
_LCD_Write::
	st -y,R10
	st -y,R20
	mov R10,R18
	mov R20,R16
	.dbline -1
	.dbline 357
; }
; 
; void LCD_Write(unsigned char address,unsigned char data)
; {
	.dbline 358
; 	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R20
	ori R16,128
	xcall _LCDwritecommand
	.dbline 359
; 	LCDprintchar(data);
	mov R16,R10
	xcall _LCDprintchar
	.dbline -2
L14:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e LCDdisplays _LCDdisplays fV
;              j -> <dead>
;              i -> R20
;         instrg -> R10,R11
;        address -> R22
	.even
_LCDdisplays::
	xcall push_xgsetF00C
	movw R10,R18
	mov R22,R16
	.dbline -1
	.dbline 363
; }
; 
; void   LCDdisplays(unsigned char address, char *instrg)
; {
	.dbline 366
; 	char i,j;
; 
; 	i = 0;
	clr R20
	.dbline 367
; 	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R22
	ori R16,128
	xcall _LCDwritecommand
	xjmp L17
L16:
	.dbline 368
; 	while(instrg[i]!=0x00) LCDprintchar(instrg[i++]);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R30,R2
	clr R31
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _LCDprintchar
L17:
	.dbline 368
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L16
X2:
	.dbline -2
L15:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym l j 1 c
	.dbsym r i 20 c
	.dbsym r instrg 10 pc
	.dbsym r address 22 c
	.dbend
	.dbfunc e LCDprints _LCDprints fV
;              j -> R22
;              i -> R20
;         instrg -> R10,R11
	.even
_LCDprints::
	xcall push_xgsetF00C
	movw R10,R16
	.dbline -1
	.dbline 372
; }
; 
; void   LCDprints(char *instrg)
; {
	.dbline 375
; 	char i,j;
; 
; 	i = 0;
	clr R20
	xjmp L21
L20:
	.dbline 376
; 	while(instrg[i]!=0x00) {
	.dbline 377
; 		if(cursorposition>=cursormax) {
	lds R2,_cursormax
	lds R3,_cursorposition
	cp R3,R2
	brlo L23
X3:
	.dbline 377
	.dbline 378
; 		   cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 379
; 		   return ; // or wrap line
	xjmp L19
L23:
	.dbline 381
; 		   }
; 		else  {
	.dbline 382
; 			  if(instrg[i]==LF) LCDwritecommand(LCDCLR);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,10
	brne L25
X4:
	.dbline 382
	ldi R16,1
	xcall _LCDwritecommand
	xjmp L26
L25:
	.dbline 383
; 			  else if(instrg[i]==CR) LCDwritecommand(LCDHOME);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,13
	brne L27
X5:
	.dbline 383
	ldi R16,16
	xcall _LCDwritecommand
	xjmp L28
L27:
	.dbline 384
; 			  else if(instrg[i]==TAB) for(j=0; j<6; j++) LCDprintchar(0x20);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,9
	brne L29
X6:
	.dbline 384
	clr R22
	xjmp L34
L31:
	.dbline 384
	ldi R16,32
	xcall _LCDprintchar
L32:
	.dbline 384
	inc R22
L34:
	.dbline 384
	cpi R22,6
	brlo L31
X7:
	xjmp L30
L29:
	.dbline 385
; 			  else LCDprintchar(instrg[i++]);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R30,R2
	clr R31
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _LCDprintchar
L30:
L28:
L26:
	.dbline 386
; 			  cursorposition++;
	lds R24,_cursorposition
	subi R24,255    ; addi 1
	sts _cursorposition,R24
	.dbline 387
; 			  }
	.dbline 388
; 		}
L21:
	.dbline 376
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	breq X9
	xjmp L20
X9:
X8:
	.dbline -2
L19:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r j 22 c
	.dbsym r i 20 c
	.dbsym r instrg 10 pc
	.dbend
	.dbfunc e LCD_Symbols _LCD_Symbols fV
;              i -> R20,R21
;          state -> R22
	.even
_LCD_Symbols::
	xcall push_xgsetF000
	mov R22,R16
	.dbline -1
	.dbline 392
; }
; 
; void LCD_Symbols(unsigned char state)
; { 	 
	.dbline 395
; 	 int i;
; 	 
; 	 if(state==ON) {
	tst R22
	brne L36
X10:
	.dbline 395
	.dbline 396
; 	 	 LCDwritecommand(LCDRAMADDRESS|0x70);
	ldi R16,240
	xcall _LCDwritecommand
	.dbline 397
; 	 	 for(i=0; i<12; i++)  LCDprintchar(0x0b);
	clr R20
	clr R21
L38:
	.dbline 397
	ldi R16,11
	xcall _LCDprintchar
L39:
	.dbline 397
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 397
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L38
X11:
	.dbline 398
; 		 }
	xjmp L37
L36:
	.dbline 399
; 	 else if(state==OFF) {
	cpi R22,1
	brne L42
X12:
	.dbline 399
	.dbline 400
; 	 	 LCDwritecommand(LCDRAMADDRESS|0x70);
	ldi R16,240
	xcall _LCDwritecommand
	.dbline 401
; 	 	 for(i=0; i<12; i++)  LCDprintchar(0x00);
	clr R20
	clr R21
L44:
	.dbline 401
	clr R16
	xcall _LCDprintchar
L45:
	.dbline 401
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 401
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L44
X13:
	.dbline 402
; 		 }
L42:
L37:
	.dbline -2
L35:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 I
	.dbsym r state 22 c
	.dbend
	.dbfunc e SetBuffers _SetBuffers fV
;              i -> R20
;         inchar -> R16
	.even
_SetBuffers::
	st -y,R20
	.dbline -1
	.dbline 406
; }
; 
; void SetBuffers(unsigned char inchar)
; {
	.dbline 409
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<12; i++) {
	clr R20
	xjmp L52
L49:
	.dbline 409
	.dbline 410
; 	     line1[i] = inchar;
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 411
; 		 line2[i] = inchar;
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 412
; 		 line3[i] = inchar;
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 413
; 		 line4[i] = inchar;
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 414
; 		 }
L50:
	.dbline 409
	inc R20
L52:
	.dbline 409
	cpi R20,12
	brlo L49
X14:
	.dbline 415
; 	 line1[12] = line2[12] = line3[12] = line4[12] = 0;
	clr R2
	sts _line4+12,R2
	sts _line3+12,R2
	sts _line2+12,R2
	sts _line1+12,R2
	.dbline -2
L48:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r inchar 16 c
	.dbend
	.dbfunc e Clear_LCD _Clear_LCD fV
;              i -> R20,R21
	.even
_Clear_LCD::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 419
; }
; 
; void Clear_LCD()
; {
	.dbline 423
;  	 int i;
; 	 
; 	 // Clear 4x12 display
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x30+i,' ');
	clr R20
	clr R21
L58:
	.dbline 423
	ldi R18,32
	mov R16,R20
	subi R16,208  ; offset = 48
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L59:
	.dbline 423
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 423
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L58
X15:
	.dbline 424
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x40+i,' ');
	clr R20
	clr R21
L62:
	.dbline 424
	ldi R18,32
	mov R16,R20
	subi R16,192  ; offset = 64
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L63:
	.dbline 424
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 424
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L62
X16:
	.dbline 425
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x50+i,' ');
	clr R20
	clr R21
L66:
	.dbline 425
	ldi R18,32
	mov R16,R20
	subi R16,176  ; offset = 80
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L67:
	.dbline 425
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 425
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L66
X17:
	.dbline 426
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x60+i,' ');
	clr R20
	clr R21
L70:
	.dbline 426
	ldi R18,32
	mov R16,R20
	subi R16,160  ; offset = 96
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L71:
	.dbline 426
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 426
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L70
X18:
	.dbline 429
; 	 
; 	 // Clear buffers
; 	 SetBuffers(' ');
	ldi R16,32
	xcall _SetBuffers
	.dbline 432
; 	 
; 	 // Clear all symbols
; 	 LCD_Symbols(OFF);
	ldi R16,1
	xcall _LCD_Symbols
	.dbline -2
L57:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r i 20 I
	.dbend
	.dbfunc e Init_LCD _Init_LCD fV
	.even
_Init_LCD::
	.dbline -1
	.dbline 443
; }
; 
; 
; /******************************************
;   LCD interface control logic:
;        CS -  0 select device
;        R/W - 0 WR, 1 RD,
;        LA0 - 0 command, 1 data
;  ******************************************/
; void Init_LCD()
; {
	.dbline 444
;      lcdchiptype = LCDCHIPE1007;  // if lcd display is E1007
	ldi R24,7
	sts _lcdchiptype,R24
	.dbline 446
; 	 
; 	 SetBit(PORTB,PINB6);  // set clock high
	sbi 0x5,6
	.dbline 448
; 	 // Reset LCD - hold in reset for 10usec
; 	 LCDCONTROL &= ~BIT(LCDRESET);  // Set Reset line low
	cbi 0x5,0
	.dbline 449
; 	 ShortDelay(200);
	ldi R16,200
	ldi R17,0
	xcall _ShortDelay
	.dbline 450
; 	 LCDCONTROL |= BIT(LCDRESET);  // Set Reset line high
	sbi 0x5,0
	.dbline 451
; 	 ShortDelay(50);
	ldi R16,50
	ldi R17,0
	xcall _ShortDelay
	.dbline 462
; 	
; 	// Static Icon off - display on - RF circuit on - clear RAM
; 	// Set display volume
; 
; // System set command
; //   D3-N2, D2-N1, D0-CG
; //   N2/1 -> 0,0  2 lines
; //   N2/1 -> 0,1  3 lines
; //   N2/1 -> 1,0  4 lines
; //   CG   -> 1 CGRAM used, 0 not used
;      LCDwritecommand(LCDSYSTEMSET|LCD4LINE|LCDCGON);
	ldi R16,105
	xcall _LCDwritecommand
	.dbline 469
; 
; // Static Display Command
; //   D1/0 - 0,0  Display OFF
; //   D1/0 - 0,1  1-2Hz blink
; //   D1/0 - 1,0  3-4Hz blink
; //   D1/0 - 1,1  Display ON
; 	 LCDwritecommand(LCDSTATICDISPLAY|LCDDISPLAYON);
	ldi R16,35
	xcall _LCDwritecommand
	.dbline 478
; 	 
; // Display control command
; //   D3-C, D2-B, D1-DC, D0-D
; //   C  -> 1 cursor on, 0 off
; //   DC -> 1 double cursor on, 0 off
; //   B  -> 1 blink on, 0 off
; //   D  -> 1 display on, 0 off	 
; //	 LCDwritecommand(LCDDISPLAY|LCDCURSORON|LCDCURSORBLINK|LCDCURSORDISPLAYON);
; 	 LCDwritecommand(LCDDISPLAY|LCDCURSORDISPLAYON);
	ldi R16,49
	xcall _LCDwritecommand
	.dbline 484
; 
; // Power Save Command
; //   D1-PS, D0-O
; //   PS -> 1 power save on, 0 off
; //   O  -> 1 oscillator circuit on, 0 off
;      LCDwritecommand(LCDPOWERSAVE|LCDPOWERSAVEOFF|LCDOSCON);
	ldi R16,66
	xcall _LCDwritecommand
	.dbline 487
; 
; 	 // Set data pointer to DDRAM
; 	 LCDwritecommand(LCDRAMADDRESS|0x30);
	ldi R16,176
	xcall _LCDwritecommand
	.dbline 490
; 
; 	 // Wait 20ms for power supply to stabilize
; 	 ShortDelay(30000);	 
	ldi R16,30000
	ldi R17,117
	xcall _ShortDelay
	.dbline 497
; 
; 	 // Power supply control
; 	 //   D2-VC, D1-VF, D0-P
; 	 //   VC -> 1 voltage regulator on, 0 off
; 	 //   VF -> 1 voltage follower on, 0 off
; 	 //   P  -> 1 voltage booster on, 0 off
; 	 LCDwritecommand(LCDPOWERSUPPLY|LCDVOLTREGON|LCDVOLTFOLLOWON|LCDVOLTBOOSTON);
	ldi R16,87
	xcall _LCDwritecommand
	.dbline 503
; //	 LCDwritecommand(LCDPOWERSUPPLY|LCDVOLTREGON|LCDVOLTFOLLOWON);
; 
; 	 // Electronic volume setting
; 	 //   D3-0 - set display brightness
; 	 // TBD - real VDD and adjust Voltage Volume accordingly
; 	 voltagevolume = 0x09;
	ldi R24,9
	sts _voltagevolume,R24
	.dbline 504
;      LCDwritecommand(LCDVOLREG|voltagevolume); 
	mov R16,R24
	ori R16,112
	xcall _LCDwritecommand
	.dbline 507
; 
; 	 // move cursor to home position command
; 	 LCDwritecommand(LCDHOME); 
	ldi R16,16
	xcall _LCDwritecommand
	.dbline 509
;  
;  	 lcdphoneantennasymbols = 0;
	clr R2
	sts _lcdphoneantennasymbols,R2
	.dbline 510
; 	 cursormax = 12;
	ldi R24,12
	sts _cursormax,R24
	.dbline 511
; 	 cursorposition = 0;
	sts _cursorposition,R2
	.dbline 512
; 	 rowptr = 1;
	ldi R24,1
	sts _rowptr,R24
	.dbline 513
; 	 colptr = 0;
	sts _colptr,R2
	.dbline 514
; 	 lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 515
; 	 lcdstate = NO_ACTIVE_STATE;
	sts _lcdstate,R2
	.dbline 516
; 	 symbolmode = NO_ACTIVE_STATE;
	sts _symbolmode,R2
	.dbline -2
L74:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayLCDBuffers _DisplayLCDBuffers fV
	.even
_DisplayLCDBuffers::
	.dbline -1
	.dbline 520
; }
; 
; void DisplayLCDBuffers()
; {
	.dbline 521
; 	 LCDdisplays(LINE1,line1);
	ldi R18,<_line1
	ldi R19,>_line1
	ldi R16,48
	xcall _LCDdisplays
	.dbline 522
;    	 LCDdisplays(LINE2,line2);
	ldi R18,<_line2
	ldi R19,>_line2
	ldi R16,64
	xcall _LCDdisplays
	.dbline 523
;    	 LCDdisplays(LINE3,line3);
	ldi R18,<_line3
	ldi R19,>_line3
	ldi R16,80
	xcall _LCDdisplays
	.dbline 524
;    	 LCDdisplays(LINE4,line4);	 
	ldi R18,<_line4
	ldi R19,>_line4
	ldi R16,96
	xcall _LCDdisplays
	.dbline -2
L75:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LoadSignon _LoadSignon fV
;              i -> <dead>
	.even
_LoadSignon::
	.dbline -1
	.dbline 528
; }
; 
; void LoadSignon()
; {
	.dbline 531
;  	 unsigned char i;
; 	 
; 	 cstrcpy(line1,line1chars);
	ldi R18,<_line1chars
	ldi R19,>_line1chars
	ldi R16,<_line1
	ldi R17,>_line1
	xcall _cstrcpy
	.dbline 532
; 	 cstrcpy(line2,line2chars);
	ldi R18,<_line2chars
	ldi R19,>_line2chars
	ldi R16,<_line2
	ldi R17,>_line2
	xcall _cstrcpy
	.dbline 533
; 	 cstrcpy(line3,line3chars);
	ldi R18,<_line3chars
	ldi R19,>_line3chars
	ldi R16,<_line3
	ldi R17,>_line3
	xcall _cstrcpy
	.dbline 534
; 	 cstrcpy(line4,line4chars);
	ldi R18,<_line4chars
	ldi R19,>_line4chars
	ldi R16,<_line4
	ldi R17,>_line4
	xcall _cstrcpy
	.dbline -2
L76:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbend
	.dbfunc e LoadSignon2 _LoadSignon2 fV
;              i -> <dead>
	.even
_LoadSignon2::
	.dbline -1
	.dbline 538
; }
; 
; void LoadSignon2()
; {
	.dbline 541
;  	 unsigned char i;
; 	 
; 	 cstrcpy(line1,line11chars);
	ldi R18,<_line11chars
	ldi R19,>_line11chars
	ldi R16,<_line1
	ldi R17,>_line1
	xcall _cstrcpy
	.dbline 542
; 	 cstrcpy(line2,line12chars);
	ldi R18,<_line12chars
	ldi R19,>_line12chars
	ldi R16,<_line2
	ldi R17,>_line2
	xcall _cstrcpy
	.dbline 543
; 	 cstrcpy(line3,line13chars);
	ldi R18,<_line13chars
	ldi R19,>_line13chars
	ldi R16,<_line3
	ldi R17,>_line3
	xcall _cstrcpy
	.dbline 544
; 	 cstrcpy(line4,line14chars);
	ldi R18,<_line14chars
	ldi R19,>_line14chars
	ldi R16,<_line4
	ldi R17,>_line4
	xcall _cstrcpy
	.dbline -2
L77:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbend
	.dbfunc e LoadSignon3 _LoadSignon3 fV
;              i -> <dead>
	.even
_LoadSignon3::
	.dbline -1
	.dbline 548
; }
; 
; void LoadSignon3()
; {
	.dbline 551
;  	 unsigned char i;
; 	 
; 	 cstrcpy(line1,line21chars);
	ldi R18,<_line21chars
	ldi R19,>_line21chars
	ldi R16,<_line1
	ldi R17,>_line1
	xcall _cstrcpy
	.dbline 552
; 	 cstrcpy(line2,line22chars);
	ldi R18,<_line22chars
	ldi R19,>_line22chars
	ldi R16,<_line2
	ldi R17,>_line2
	xcall _cstrcpy
	.dbline 553
; 	 cstrcpy(line3,line23chars);
	ldi R18,<_line23chars
	ldi R19,>_line23chars
	ldi R16,<_line3
	ldi R17,>_line3
	xcall _cstrcpy
	.dbline 554
; 	 cstrcpy(line4,line24chars);
	ldi R18,<_line24chars
	ldi R19,>_line24chars
	ldi R16,<_line4
	ldi R17,>_line4
	xcall _cstrcpy
	.dbline -2
L78:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbend
	.dbfunc e ShiftUpLine _ShiftUpLine fV
;              i -> R20
	.even
_ShiftUpLine::
	st -y,R20
	.dbline -1
	.dbline 558
; }
; 
; void ShiftUpLine()
; {
	.dbline 561
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<12; i++) {
	clr R20
	xjmp L83
L80:
	.dbline 561
	.dbline 562
; 	     line1[i] = line2[i];
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 563
; 		 line2[i] = line3[i];
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 564
; 		 line3[i] = line4[i];
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 565
; 		 line4[i] = ' ';
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,32
	std z+0,R24
	.dbline 566
; 		 }
L81:
	.dbline 561
	inc R20
L83:
	.dbline 561
	cpi R20,12
	brsh X20
	xjmp L80
X20:
X19:
	.dbline 567
;      DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 568
; 	 cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline -2
L79:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e PutCharinBuffer _PutCharinBuffer fV
;         inchar -> R10
;        address -> R18
;            row -> R16
	.even
_PutCharinBuffer::
	st -y,R10
	ldd R10,y+1
	.dbline -1
	.dbline 572
; }
; 
; void PutCharinBuffer(unsigned char row,unsigned char address,unsigned char inchar)
; {
	.dbline 573
;     if(row==0)  line1[address] = inchar;
	tst R16
	brne L85
X21:
	.dbline 573
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L86
L85:
	.dbline 574
; 	else if(row==1)  line2[address] = inchar;
	cpi R16,1
	brne L87
X22:
	.dbline 574
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L88
L87:
	.dbline 575
; 	else if(row==2)  line3[address] = inchar;
	cpi R16,2
	brne L89
X23:
	.dbline 575
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L90
L89:
	.dbline 576
; 	else if(row==3)  line4[address] = inchar;
	cpi R16,3
	brne L91
X24:
	.dbline 576
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
L91:
L90:
L88:
L86:
	.dbline -2
L84:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym r address 18 c
	.dbsym r row 16 c
	.dbend
	.dbfunc e LCD_Dsymbol _LCD_Dsymbol fV
;          state -> R20
	.even
_LCD_Dsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 580
; }
; 
; void LCD_Dsymbol(unsigned char state)
; {
	.dbline 581
;     if(state==ON) LCD_Write(0x70,0x08);
	tst R20
	brne L94
X25:
	.dbline 581
	ldi R18,8
	ldi R16,112
	xcall _LCD_Write
	xjmp L95
L94:
	.dbline 582
; 	else if(state==OFF) LCD_Write(0x70,0);
	cpi R20,1
	brne L96
X26:
	.dbline 582
	clr R18
	ldi R16,112
	xcall _LCD_Write
L96:
L95:
	.dbline -2
L93:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Rsymbol _LCD_Rsymbol fV
;          state -> R20
	.even
_LCD_Rsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 586
; }
; 
; void LCD_Rsymbol(unsigned char state)
; {
	.dbline 587
;     if(state==ON) LCD_Write(0x75,0x02);
	tst R20
	brne L99
X27:
	.dbline 587
	ldi R18,2
	ldi R16,117
	xcall _LCD_Write
	xjmp L100
L99:
	.dbline 588
; 	else if(state==OFF) LCD_Write(0x75,0);
	cpi R20,1
	brne L101
X28:
	.dbline 588
	clr R18
	ldi R16,117
	xcall _LCD_Write
L101:
L100:
	.dbline -2
L98:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Vsymbol _LCD_Vsymbol fV
;          state -> R20
	.even
_LCD_Vsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 592
; }
; 
; void LCD_Vsymbol(unsigned char state)
; {
	.dbline 593
;     if(state==ON) LCD_Write(0x78,0x08);
	tst R20
	brne L104
X29:
	.dbline 593
	ldi R18,8
	ldi R16,120
	xcall _LCD_Write
	xjmp L105
L104:
	.dbline 594
; 	else if(state==OFF) LCD_Write(0x78,0);
	cpi R20,1
	brne L106
X30:
	.dbline 594
	clr R18
	ldi R16,120
	xcall _LCD_Write
L106:
L105:
	.dbline -2
L103:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Phone _LCD_Phone fV
;          state -> R20
	.even
_LCD_Phone::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 598
; }
; 
; void LCD_Phone(unsigned char state)
; {
	.dbline 599
;     if(state==LCD_PHONE_ON) {
	cpi R20,1
	brne L109
X31:
	.dbline 599
	.dbline 600
; 	    lcdphoneantennasymbols |= LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,2
	sts _lcdphoneantennasymbols,R24
	.dbline 601
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 602
; 		LCD_Write(0x74,0);
	clr R18
	ldi R16,116
	xcall _LCD_Write
	.dbline 603
; 	    }
	xjmp L110
L109:
	.dbline 604
; 	else if(state==LCD_SLASHPHONE) {
	cpi R20,2
	brne L111
X32:
	.dbline 604
	.dbline 605
; 	    lcdphoneantennasymbols |= LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,2
	sts _lcdphoneantennasymbols,R24
	.dbline 606
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 607
; 		LCD_Write(0x74,0x08);
	ldi R18,8
	ldi R16,116
	xcall _LCD_Write
	.dbline 608
; 	    }
	xjmp L112
L111:
	.dbline 609
; 	else if(state==LCD_PHONE_OFF) {
	cpi R20,3
	brne L113
X33:
	.dbline 609
	.dbline 610
; 	    lcdphoneantennasymbols &= ~LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,253
	sts _lcdphoneantennasymbols,R24
	.dbline 611
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 612
; 		LCD_Write(0x74,0);
	clr R18
	ldi R16,116
	xcall _LCD_Write
	.dbline 613
; 	    }
L113:
L112:
L110:
	.dbline -2
L108:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Envelope _LCD_Envelope fV
;          state -> R20
	.even
_LCD_Envelope::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 617
; }
; 
; void LCD_Envelope(unsigned char state)
; {
	.dbline 618
;     if(state==ON) LCD_Write(0x76,0x02);
	tst R20
	brne L116
X34:
	.dbline 618
	ldi R18,2
	ldi R16,118
	xcall _LCD_Write
	xjmp L117
L116:
	.dbline 619
; 	else if(state==OFF) LCD_Write(0x76,0);
	cpi R20,1
	brne L118
X35:
	.dbline 619
	clr R18
	ldi R16,118
	xcall _LCD_Write
L118:
L117:
	.dbline -2
L115:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Battery _LCD_Battery fV
;          level -> R20
	.even
_LCD_Battery::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 623
; }
; 
; void LCD_Battery(unsigned char level)
; {
	.dbline 624
;  	 if(level==LCD_BATTERY_EMPTY)  {
	cpi R20,2
	brne L121
X36:
	.dbline 624
	.dbline 625
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 626
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 627
; 	     LCD_Write(0x7b,0);
	clr R18
	ldi R16,123
	xcall _LCD_Write
	.dbline 628
; 		 }
L121:
	.dbline 629
;  	 if(level==LCD_BATTERY_QUARTER)  {
	cpi R20,3
	brne L123
X37:
	.dbline 629
	.dbline 630
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 631
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 632
; 	     LCD_Write(0x7b,0x08);
	ldi R18,8
	ldi R16,123
	xcall _LCD_Write
	.dbline 633
; 		 }
L123:
	.dbline 634
;  	 if(level==LCD_BATTERY_HALF)  {
	cpi R20,4
	brne L125
X38:
	.dbline 634
	.dbline 635
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 636
; 	     LCD_Write(0x7a,0x02);
	ldi R18,2
	ldi R16,122
	xcall _LCD_Write
	.dbline 637
; 	     LCD_Write(0x7b,0x08);
	ldi R18,8
	ldi R16,123
	xcall _LCD_Write
	.dbline 638
; 		 }
L125:
	.dbline 639
;  	 if(level==LCD_BATTERY_THREEQUARTER)  {
	cpi R20,5
	brne L127
X39:
	.dbline 639
	.dbline 640
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 641
; 	     LCD_Write(0x7a,0x02);
	ldi R18,2
	ldi R16,122
	xcall _LCD_Write
	.dbline 642
; 	     LCD_Write(0x7b,0x0b);
	ldi R18,11
	ldi R16,123
	xcall _LCD_Write
	.dbline 643
; 		 }
L127:
	.dbline 644
;  	 if(level==LCD_BATTERY_FULL)  {
	cpi R20,6
	brne L129
X40:
	.dbline 644
	.dbline 645
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 646
; 	     LCD_Write(0x7a,0x0b);
	ldi R18,11
	ldi R16,122
	xcall _LCD_Write
	.dbline 647
; 	     LCD_Write(0x7b,0x0b);
	ldi R18,11
	ldi R16,123
	xcall _LCD_Write
	.dbline 648
; 		 }
L129:
	.dbline 649
;  	 if(level==LCD_BATTERY_OFF)  {
	cpi R20,1
	brne L131
X41:
	.dbline 649
	.dbline 650
; 	     LCD_Write(0x79,0);
	clr R18
	ldi R16,121
	xcall _LCD_Write
	.dbline 651
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 652
; 	     LCD_Write(0x7b,0);
	clr R18
	ldi R16,123
	xcall _LCD_Write
	.dbline 653
; 		 }
L131:
	.dbline -2
L120:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r level 20 c
	.dbend
	.dbfunc e LCD_Antenna _LCD_Antenna fV
;          level -> R20
	.even
_LCD_Antenna::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 657
; }
; 
; void LCD_Antenna(unsigned char level)
; {
	.dbline 658
;  	 if(level==LCD_ANTENNA_EMPTY)  {
	cpi R20,2
	brne L134
X42:
	.dbline 658
	.dbline 659
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 660
; 	     LCD_Write(0x71,0x08);
	ldi R18,8
	ldi R16,113
	xcall _LCD_Write
	.dbline 661
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 662
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 663
; 		 }
L134:
	.dbline 664
;   	 if(level==LCD_ANTENNA_QUARTER)  {
	cpi R20,3
	brne L136
X43:
	.dbline 664
	.dbline 665
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 666
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 667
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 668
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 669
; 		 }
L136:
	.dbline 670
;  	 if(level==LCD_ANTENNA_HALF)  {
	cpi R20,4
	brne L138
X44:
	.dbline 670
	.dbline 671
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 672
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 673
; 	     LCD_Write(0x72,0x08);
	ldi R18,8
	ldi R16,114
	xcall _LCD_Write
	.dbline 674
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 675
; 		 }
L138:
	.dbline 676
;  	 if(level==LCD_ANTENNA_THREEQUARTER)  {
	cpi R20,5
	brne L140
X45:
	.dbline 676
	.dbline 677
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 678
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 679
; 	     LCD_Write(0x72,0x0b);
	ldi R18,11
	ldi R16,114
	xcall _LCD_Write
	.dbline 680
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 681
; 		 }
L140:
	.dbline 682
;  	 if(level==LCD_ANTENNA_FULL)  {
	cpi R20,6
	brne L142
X46:
	.dbline 682
	.dbline 683
; 	     lcdphoneantennasymbols |= LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,8
	sts _lcdphoneantennasymbols,R24
	.dbline 684
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 685
; 	     LCD_Write(0x72,0x0b);
	ldi R18,11
	ldi R16,114
	xcall _LCD_Write
	.dbline 686
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 687
; 		 }
L142:
	.dbline 688
;  	 if(level==LCD_ANTENNA_OFF)  {
	cpi R20,1
	brne L144
X47:
	.dbline 688
	.dbline 689
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 690
; 	     LCD_Write(0x71,0);
	clr R18
	ldi R16,113
	xcall _LCD_Write
	.dbline 691
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 692
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 693
; 		 }
L144:
	.dbline -2
L133:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r level 20 c
	.dbend
	.dbfunc e GetRowfromLine _GetRowfromLine fc
;           line -> R16
	.even
_GetRowfromLine::
	.dbline -1
	.dbline 697
; }
; 
; unsigned char GetRowfromLine(unsigned char line)
; {
	.dbline 698
;  	 if(line==LINE1) return 0;
	cpi R16,48
	brne L147
X48:
	.dbline 698
	clr R16
	xjmp L146
L147:
	.dbline 699
; 	 if(line==LINE2) return 1;
	cpi R16,64
	brne L149
X49:
	.dbline 699
	ldi R16,1
	xjmp L146
L149:
	.dbline 700
; 	 if(line==LINE3) return 2;
	cpi R16,80
	brne L151
X50:
	.dbline 700
	ldi R16,2
	xjmp L146
L151:
	.dbline 701
; 	 if(line==LINE4) return 3;
	cpi R16,96
	brne L153
X51:
	.dbline 701
	ldi R16,3
	xjmp L146
L153:
	.dbline 702
; 	 return 0;
	clr R16
	.dbline -2
L146:
	.dbline 0 ; func end
	ret
	.dbsym r line 16 c
	.dbend
	.dbfunc e SendCharToDisplay _SendCharToDisplay fV
;         inchar -> R10
	.even
_SendCharToDisplay::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 706
; }
; 
; void SendCharToDisplay(unsigned char inchar)
; {
	.dbline 707
; 	if(cursorposition>11) {
	ldi R24,11
	lds R2,_cursorposition
	cp R24,R2
	brsh L156
X52:
	.dbline 707
	.dbline 708
; 		if(lineptr==LINE4) ShiftUpLine();
	lds R24,_lineptr
	cpi R24,96
	brne L158
X53:
	.dbline 708
	xcall _ShiftUpLine
	xjmp L159
L158:
	.dbline 709
; 		else {
	.dbline 710
; 			lineptr += 0x10;
	lds R24,_lineptr
	subi R24,240    ; addi 16
	sts _lineptr,R24
	.dbline 711
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 712
; 			}
L159:
	.dbline 713
; 		}				
L156:
	.dbline 714
; 	LCDDisplayChar(lineptr+cursorposition,inchar);
	mov R18,R10
	lds R2,_cursorposition
	lds R16,_lineptr
	add R16,R2
	xcall _LCDDisplayChar
	.dbline 715
; 	PutCharinBuffer(GetRowfromLine(lineptr),cursorposition,inchar);
	lds R16,_lineptr
	xcall _GetRowfromLine
	std y+0,R10
	lds R18,_cursorposition
	xcall _PutCharinBuffer
	.dbline 716
; 	cursorposition++;
	lds R24,_cursorposition
	subi R24,255    ; addi 1
	sts _cursorposition,R24
	.dbline -2
L155:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e IncrementLinePtr _IncrementLinePtr fV
	.even
_IncrementLinePtr::
	.dbline -1
	.dbline 720
; }
; 
; void IncrementLinePtr()
; {
	.dbline 721
;     if(lineptr==LINE1)  lineptr = LINE2;
	lds R24,_lineptr
	cpi R24,48
	brne L161
X54:
	.dbline 721
	ldi R24,64
	sts _lineptr,R24
	xjmp L162
L161:
	.dbline 722
; 	else if(lineptr==LINE2) lineptr = LINE3;
	lds R24,_lineptr
	cpi R24,64
	brne L163
X55:
	.dbline 722
	ldi R24,80
	sts _lineptr,R24
	xjmp L164
L163:
	.dbline 723
; 	else if(lineptr==LINE3) lineptr = LINE4;
	lds R24,_lineptr
	cpi R24,80
	brne L165
X56:
	.dbline 723
	ldi R24,96
	sts _lineptr,R24
L165:
L164:
L162:
	.dbline -2
L160:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ParseEscSubCommand _ParseEscSubCommand fV
;         inchar -> R20
	.even
_ParseEscSubCommand::
	xcall push_xgsetF000
	mov R20,R16
	.dbline -1
	.dbline 727
; }
; 
; void ParseEscSubCommand(unsigned char inchar)
; {
	.dbline 728
;  	 switch (symbolmode) {
	lds R22,_symbolmode
	clr R23
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	breq L171
X57:
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	breq L178
X58:
	cpi R22,11
	ldi R30,0
	cpc R23,R30
	breq L185
X59:
	xjmp L168
L171:
	.dbline 730
; 		case TWI_ADDRESS_STATE:
; 		    if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_ON);
	cpi R20,1
	brne L172
X60:
	.dbline 730
	ldi R16,1
	xcall _LCD_Phone
	xjmp L169
L172:
	.dbline 731
; 			else if(inchar==LCD_SLASHPHONE) LCD_Phone(LCD_SLASHPHONE);
	cpi R20,2
	brne L174
X61:
	.dbline 731
	ldi R16,2
	xcall _LCD_Phone
	xjmp L169
L174:
	.dbline 732
; 			else if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_OFF);
	cpi R20,1
	brne L169
X62:
	.dbline 732
	ldi R16,3
	xcall _LCD_Phone
	.dbline 733
; 			break;
	xjmp L169
L178:
	.dbline 735
; 		case LED_BLINK_STATE:
; 		    if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_ON);
	cpi R20,1
	brne L179
X63:
	.dbline 735
	ldi R16,1
	xcall _LCD_Phone
	xjmp L169
L179:
	.dbline 736
; 			else if(inchar==LCD_SLASHPHONE) LCD_Phone(LCD_SLASHPHONE);
	cpi R20,2
	brne L181
X64:
	.dbline 736
	ldi R16,2
	xcall _LCD_Phone
	xjmp L169
L181:
	.dbline 737
; 			else if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_OFF);
	cpi R20,1
	brne L169
X65:
	.dbline 737
	ldi R16,3
	xcall _LCD_Phone
	.dbline 738
; 			break;
	xjmp L169
L185:
	.dbline 740
; 		case VOLTAGE_STATE:
; 		    if(inchar=='o') LCD_Vsymbol(ON);
	cpi R20,111
	brne L186
X66:
	.dbline 740
	clr R16
	xcall _LCD_Vsymbol
	xjmp L169
L186:
	.dbline 741
; 			else if(inchar=='f') LCD_Vsymbol(OFF);
	cpi R20,102
	brne L169
X67:
	.dbline 741
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 742
; 			break;
L168:
L169:
	.dbline 744
; 		}
;  	 lcdstate = NO_ACTIVE_STATE;
	clr R2
	sts _lcdstate,R2
	.dbline -2
L167:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e ParseSymbolCommand _ParseSymbolCommand fV
;         inchar -> R20
	.even
_ParseSymbolCommand::
	xcall push_xgsetF000
	mov R20,R16
	.dbline -1
	.dbline 748
; }
; 
; void ParseSymbolCommand(unsigned char inchar)
; {
	.dbline 749
;  	 switch (symbolmode) {
	lds R22,_symbolmode
	clr R23
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	breq L194
X68:
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	breq L195
X69:
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	breq L196
X70:
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	breq L201
X71:
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	breq L206
X72:
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	breq L211
X73:
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne X83
	xjmp L216
X83:
X74:
	xjmp L191
L194:
	.dbline 751
; 		case ANTENNA_STATE:
; 		    LCD_Antenna(inchar);
	mov R16,R20
	xcall _LCD_Antenna
	.dbline 752
; 			break;
	xjmp L192
L195:
	.dbline 754
; 		case BATTERY_STATE:
; 		    LCD_Battery(inchar);
	mov R16,R20
	xcall _LCD_Battery
	.dbline 755
; 			break;
	xjmp L192
L196:
	.dbline 757
; 		case VSYM_STATE:
; 		    if(inchar=='o') LCD_Vsymbol(ON);
	cpi R20,111
	brne L197
X75:
	.dbline 757
	clr R16
	xcall _LCD_Vsymbol
	xjmp L192
L197:
	.dbline 758
; 			else if(inchar=='f') LCD_Vsymbol(OFF);
	cpi R20,102
	brne L192
X76:
	.dbline 758
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 759
; 			break;
	xjmp L192
L201:
	.dbline 761
; 		case DSYM_STATE:
; 		    if(inchar=='o') LCD_Dsymbol(ON);
	cpi R20,111
	brne L202
X77:
	.dbline 761
	clr R16
	xcall _LCD_Dsymbol
	xjmp L192
L202:
	.dbline 762
; 			else if(inchar=='f') LCD_Dsymbol(OFF);
	cpi R20,102
	brne L192
X78:
	.dbline 762
	ldi R16,1
	xcall _LCD_Dsymbol
	.dbline 763
; 			break;
	xjmp L192
L206:
	.dbline 765
; 		case RSYM_STATE:
; 		    if(inchar=='o') LCD_Rsymbol(ON);
	cpi R20,111
	brne L207
X79:
	.dbline 765
	clr R16
	xcall _LCD_Rsymbol
	xjmp L192
L207:
	.dbline 766
; 			else if(inchar=='f') LCD_Rsymbol(OFF);
	cpi R20,102
	brne L192
X80:
	.dbline 766
	ldi R16,1
	xcall _LCD_Rsymbol
	.dbline 767
; 			break;
	xjmp L192
L211:
	.dbline 769
; 		case ENVELOPE_STATE:
; 		    if(inchar=='o') LCD_Envelope(ON);
	cpi R20,111
	brne L212
X81:
	.dbline 769
	clr R16
	xcall _LCD_Envelope
	xjmp L192
L212:
	.dbline 770
; 			else if(inchar=='f') LCD_Envelope(OFF);
	cpi R20,102
	brne L192
X82:
	.dbline 770
	ldi R16,1
	xcall _LCD_Envelope
	.dbline 771
; 			break;
	xjmp L192
L216:
	.dbline 773
; 		case PHONE_STATE:
; 		    LCD_Phone(inchar);
	mov R16,R20
	xcall _LCD_Phone
	.dbline 774
; 			break;
L191:
L192:
	.dbline 776
; 	     }
;  	 lcdstate = NO_ACTIVE_STATE;
	clr R2
	sts _lcdstate,R2
	.dbline 777
; 	 symbolmode = NO_ACTIVE_STATE;
	sts _symbolmode,R2
	.dbline -2
L190:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e ParseEscCommand _ParseEscCommand fV
;         inchar -> R10
	.even
_ParseEscCommand::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 781
; }
; 
; void ParseEscCommand(unsigned char inchar)
; {
	.dbline 782
;     switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,99
	ldi R30,0
	cpc R21,R30
	brne X98
	xjmp L221
X98:
X84:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	brne X99
	xjmp L228
X99:
X85:
	ldi R24,102
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L234
X86:
L233:
	cpi R20,49
	ldi R30,0
	cpc R21,R30
	brne X100
	xjmp L223
X100:
X87:
	cpi R20,50
	ldi R30,0
	cpc R21,R30
	brne X101
	xjmp L224
X101:
X88:
	cpi R20,51
	ldi R30,0
	cpc R21,R30
	brne X102
	xjmp L225
X102:
X89:
	cpi R20,52
	ldi R30,0
	cpc R21,R30
	brne X103
	xjmp L226
X103:
X90:
	xjmp L218
L234:
	cpi R20,108
	ldi R30,0
	cpc R21,R30
	brne X104
	xjmp L231
X104:
X91:
	cpi R20,111
	ldi R30,0
	cpc R21,R30
	brne X105
	xjmp L227
X105:
X92:
	cpi R20,108
	ldi R30,0
	cpc R21,R30
	brge X106
	xjmp L218
X106:
X93:
L235:
	cpi R20,115
	ldi R30,0
	cpc R21,R30
	brne X107
	xjmp L229
X107:
X94:
	cpi R20,116
	ldi R30,0
	cpc R21,R30
	brne X108
	xjmp L232
X108:
X95:
	cpi R20,118
	ldi R30,0
	cpc R21,R30
	brne X109
	xjmp L230
X109:
X96:
	cpi R20,120
	ldi R30,0
	cpc R21,R30
	breq L222
X97:
	xjmp L218
L221:
	.dbline 784
; 	    case 'c':
; 		    Clear_LCD();
	xcall _Clear_LCD
	.dbline 785
; 			textdisplaymode = ACTIVE;
	ldi R24,97
	sts _textdisplaymode,R24
	.dbline 786
; 			lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 787
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 788
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 789
; 			break;
	xjmp L219
L222:
	.dbline 791
; 		case 'x':
; 		    Clear_LCD();
	xcall _Clear_LCD
	.dbline 792
; 			textdisplaymode = INACTIVE;
	ldi R24,105
	sts _textdisplaymode,R24
	.dbline 793
; 			lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 794
; 		    cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 795
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 796
; 			break;
	xjmp L219
L223:
	.dbline 798
; 		case '1':
; 		    lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 799
; 		    cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 800
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 801
; 			break;
	xjmp L219
L224:
	.dbline 803
; 		case '2':
; 		    lineptr = LINE2;
	ldi R24,64
	sts _lineptr,R24
	.dbline 804
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 805
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 806
; 			break;
	xjmp L219
L225:
	.dbline 808
; 		case '3':
; 		    lineptr = LINE3;
	ldi R24,80
	sts _lineptr,R24
	.dbline 809
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 810
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 811
; 			break;
	xjmp L219
L226:
	.dbline 813
; 		case '4':
; 		    lineptr = LINE4;
	ldi R24,96
	sts _lineptr,R24
	.dbline 814
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 815
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 816
; 			break;
	xjmp L219
L227:
	.dbline 819
; 		case 'o':
; 			//SendCharToDisplay('o');
; 		    LCD_LED_Power(ON);
	clr R16
	xcall _LCD_LED_Power
	.dbline 820
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 821
; 			break;
	xjmp L219
L228:
	.dbline 824
; 		case 'f':
; 			//SendCharToDisplay('f');
; 		    LCD_LED_Power(OFF);
	ldi R16,1
	xcall _LCD_LED_Power
	.dbline 825
; 			escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 826
; 			break;
	xjmp L219
L229:
	.dbline 828
; 		case 's':
; 		    lcdstate = LCD_SYMBOL_STATE;
	ldi R24,9
	sts _lcdstate,R24
	.dbline 829
; 			break;
	xjmp L219
L230:
	.dbline 831
; 		case 'v':
; 		    lcdstate = VOLTAGE_STATE;
	ldi R24,11
	sts _lcdstate,R24
	.dbline 832
; 			break;
	xjmp L219
L231:
	.dbline 834
; 		case 'l':
; 		    lcdstate = LED_BLINK_STATE;
	ldi R24,10
	sts _lcdstate,R24
	.dbline 835
; 			break;
	xjmp L219
L232:
	.dbline 837
; 		case 't':
; 		    lcdstate = TWI_ADDRESS_STATE;
	ldi R24,8
	sts _lcdstate,R24
	.dbline 838
; 			break;
	xjmp L219
L218:
	.dbline 840
; 		default:
; 		    escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 841
; 			break;
L219:
	.dbline 843
; 		}
; 	escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline -2
L217:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e ParseChar _ParseChar fV
;         inchar -> R10
	.even
_ParseChar::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 847
; }
; 
; void ParseChar(unsigned char inchar)
; {
	.dbline 848
; 	if(escmode==ON) {
	lds R2,_escmode
	tst R2
	brne L237
X110:
	.dbline 848
	.dbline 849
; 		ParseEscCommand(inchar);
	mov R16,R10
	xcall _ParseEscCommand
	.dbline 850
; 		}
	xjmp L238
L237:
	.dbline 851
; 	else {
	.dbline 852
; 	    if(symbolmode)  ParseSymbolCommand(inchar);
	lds R2,_symbolmode
	tst R2
	breq L239
X111:
	.dbline 852
	mov R16,R10
	xcall _ParseSymbolCommand
	xjmp L240
L239:
	.dbline 853
; 	    else if(lcdstate==LCD_SYMBOL_STATE) symbolmode = inchar;
	lds R24,_lcdstate
	cpi R24,9
	brne L241
X112:
	.dbline 853
	sts _symbolmode,R10
	xjmp L242
L241:
	.dbline 854
; 		else if(lcdstate) ParseEscSubCommand(inchar);
	lds R2,_lcdstate
	tst R2
	breq L243
X113:
	.dbline 854
	mov R16,R10
	xcall _ParseEscSubCommand
	xjmp L244
L243:
	.dbline 855
; 		else {
	.dbline 856
; 	      switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne X127
	xjmp L253
X127:
X114:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	brne X128
	xjmp L254
X128:
X115:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brne X129
	xjmp L255
X129:
X116:
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brne X130
	xjmp L256
X130:
X117:
	cpi R20,5
	ldi R30,0
	cpc R21,R30
	brne X131
	xjmp L257
X131:
X118:
	cpi R20,6
	ldi R30,0
	cpc R21,R30
	brne X132
	xjmp L258
X132:
X119:
	cpi R20,7
	ldi R30,0
	cpc R21,R30
	brne X133
	xjmp L259
X133:
X120:
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brne X134
	xjmp L260
X134:
X121:
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	breq L250
X122:
	cpi R20,13
	ldi R30,0
	cpc R21,R30
	breq L249
X123:
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brge X135
	xjmp L245
X135:
X124:
L261:
	cpi R20,27
	ldi R30,0
	cpc R21,R30
	breq L248
X125:
	xjmp L245
L248:
	.dbline 858
; 		    case ESC:
; 				escmode = ON;  
	clr R2
	sts _escmode,R2
	.dbline 859
; 				break;
	xjmp L246
L249:
	.dbline 861
; 		    case CR:
; 				cursorposition = 0; 
	clr R2
	sts _cursorposition,R2
	.dbline 862
; 				break;
	xjmp L246
L250:
	.dbline 864
; 		    case LF:
; 				if(lineptr==LINE4) ShiftUpLine();
	lds R24,_lineptr
	cpi R24,96
	brne L251
X126:
	.dbline 864
	xcall _ShiftUpLine
	xjmp L246
L251:
	.dbline 865
;  				else IncrementLinePtr();
	xcall _IncrementLinePtr
	.dbline 866
; 				break;
	xjmp L246
L253:
	.dbline 868
; 		    case 0x01:
; 				LCD_Vsymbol(ON); 
	clr R16
	xcall _LCD_Vsymbol
	.dbline 869
; 				break;
	xjmp L246
L254:
	.dbline 871
; 		    case 0x02:
; 				LCD_Vsymbol(OFF);  
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 872
; 				break;
	xjmp L246
L255:
	.dbline 874
; 		    case 0x03:
; 				LCD_Dsymbol(ON); 
	clr R16
	xcall _LCD_Dsymbol
	.dbline 875
; 				break;
	xjmp L246
L256:
	.dbline 877
; 		    case 0x04:
; 				LCD_Dsymbol(OFF);  
	ldi R16,1
	xcall _LCD_Dsymbol
	.dbline 878
; 				break;
	xjmp L246
L257:
	.dbline 880
; 		    case 0x05:
; 				LCD_Rsymbol(ON); 
	clr R16
	xcall _LCD_Rsymbol
	.dbline 881
; 				break;
	xjmp L246
L258:
	.dbline 883
; 		    case 0x06:
; 				LCD_Rsymbol(OFF);  
	ldi R16,1
	xcall _LCD_Rsymbol
	.dbline 884
; 				break;
	xjmp L246
L259:
	.dbline 886
; 		    case 0x07:
; 				LCD_Envelope(ON); 
	clr R16
	xcall _LCD_Envelope
	.dbline 887
; 				break;
	xjmp L246
L260:
	.dbline 889
; 		    case 0x08:
; 				LCD_Envelope(OFF);  
	ldi R16,1
	xcall _LCD_Envelope
	.dbline 890
; 				break;
	xjmp L246
L245:
	.dbline 892
; 			default:
; 			    SendCharToDisplay(inchar);
	mov R16,R10
	xcall _SendCharToDisplay
	.dbline 893
; 				break;
L246:
	.dbline 895
; 			}
; 		  }
L244:
L242:
L240:
	.dbline 896
; 		}
L238:
	.dbline -2
L236:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e ParseStrg _ParseStrg fV
;              i -> R10
;         instrg -> R12,R13
	.even
_ParseStrg::
	xcall push_xgset003C
	movw R12,R16
	.dbline -1
	.dbline 900
; }
; 
; void ParseStrg(unsigned char *instrg)
; {
	.dbline 903
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<strlen(instrg); i++)  ParseChar(instrg[i]);
	clr R10
	xjmp L266
L263:
	.dbline 903
	mov R30,R10
	clr R31
	add R30,R12
	adc R31,R13
	ldd R16,z+0
	xcall _ParseChar
L264:
	.dbline 903
	inc R10
L266:
	.dbline 903
	movw R16,R12
	xcall _strlen
	mov R2,R10
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L263
X136:
	.dbline -2
L262:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r i 10 c
	.dbsym r instrg 12 pc
	.dbend
	.dbfunc e PutStringinBuffer _PutStringinBuffer fV
;              i -> R10
;           strg -> R12,R13
;         column -> R14
;            row -> R20
	.even
_PutStringinBuffer::
	xcall push_xgset30FC
	mov R14,R18
	mov R20,R16
	sbiw R28,1
	ldd R12,y+9
	ldd R13,y+10
	.dbline -1
	.dbline 907
; }
; 
; void PutStringinBuffer(unsigned char row,unsigned char column,char *strg)
; {	 
	.dbline 910
; 	 unsigned char i;
; 	 
; 	 for(i=0; i<strlen(strg); i++)  PutCharinBuffer(row,column+i,strg[i]);
	clr R10
	xjmp L271
L268:
	.dbline 910
	mov R30,R10
	clr R31
	add R30,R12
	adc R31,R13
	ldd R2,z+0
	std y+0,R2
	mov R18,R14
	add R18,R10
	mov R16,R20
	xcall _PutCharinBuffer
L269:
	.dbline 910
	inc R10
L271:
	.dbline 910
	movw R16,R12
	xcall _strlen
	mov R2,R10
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L268
X137:
	.dbline -2
L267:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset30FC
	.dbsym r i 10 c
	.dbsym r strg 12 pc
	.dbsym r column 14 c
	.dbsym r row 20 c
	.dbend
	.dbfunc e GetLine _GetLine fc
;            row -> R16
	.even
_GetLine::
	.dbline -1
	.dbline 914
; }
; 
; unsigned char GetLine(unsigned char row)
; {
	.dbline 915
;     if(row==0) return LINE1;
	tst R16
	brne L273
X138:
	.dbline 915
	ldi R16,48
	xjmp L272
L273:
	.dbline 916
; 	if(row==1) return LINE2;
	cpi R16,1
	brne L275
X139:
	.dbline 916
	ldi R16,64
	xjmp L272
L275:
	.dbline 917
; 	if(row==2) return LINE3;
	cpi R16,2
	brne L277
X140:
	.dbline 917
	ldi R16,80
	xjmp L272
L277:
	.dbline 918
; 	if(row==3) return LINE4;
	cpi R16,3
	brne L279
X141:
	.dbline 918
	ldi R16,96
	xjmp L272
L279:
	.dbline 919
; 	return LINE1;
	ldi R16,48
	.dbline -2
L272:
	.dbline 0 ; func end
	ret
	.dbsym r row 16 c
	.dbend
	.dbfunc e Display_Voltage_Volume _Display_Voltage_Volume fV
;    analogvalue -> <dead>
;           strg -> y+2
;         column -> R20
;            row -> R10
	.even
_Display_Voltage_Volume::
	st -y,R10
	st -y,R20
	mov R20,R18
	mov R10,R16
	sbiw R28,7
	.dbline -1
	.dbline 923
; }
; 
; void Display_Voltage_Volume(unsigned char row,unsigned char column)
; {
	.dbline 927
;  	 char strg[5];
;  	 int analogvalue;
; 	 
; 	 PutStringinBuffer(row,column,"Volt v=");
	ldi R24,<L282
	ldi R25,>L282
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 928
; 	 bytetohex(voltagevolume);
	lds R16,_voltagevolume
	xcall _bytetohex
	.dbline 929
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 930
; 	 PutStringinBuffer(row,column+7,hexbyte);
	ldi R24,<_hexbyte
	ldi R25,>_hexbyte
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,249    ; addi 7
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L281:
	.dbline 0 ; func end
	adiw R28,7
	ld R20,y+
	ld R10,y+
	ret
	.dbsym l analogvalue 3 I
	.dbsym l strg 2 A[5:5]c
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Int2strg _Int2strg fV
;   tenthousands -> <dead>
;           tens -> R20,R21
;      thousands -> R12,R13
;       hundreds -> R22,R23
;       intvalue -> R10,R11
	.even
_Int2strg::
	xcall push_xgsetF03C
	movw R10,R16
	.dbline -1
	.dbline 934
; }
; 
; void Int2strg(int intvalue)
; {
	.dbline 937
;  	 int  tenthousands, thousands, hundreds, tens;
; 
; 	 thousands = intvalue/1000;
	ldi R18,1000
	ldi R19,3
	movw R16,R10
	xcall div16s
	movw R12,R16
	.dbline 938
; 	 intvalue -= (thousands*1000);
	ldi R16,1000
	ldi R17,3
	movw R18,R12
	xcall empy16s
	sub R10,R16
	sbc R11,R17
	.dbline 939
; 	 hundreds = intvalue/100;
	ldi R18,100
	ldi R19,0
	movw R16,R10
	xcall div16s
	movw R22,R16
	.dbline 940
; 	 intvalue -= (hundreds*100);
	ldi R16,100
	ldi R17,0
	movw R18,R22
	xcall empy16s
	sub R10,R16
	sbc R11,R17
	.dbline 941
; 	 tens = intvalue/10;
	ldi R18,10
	ldi R19,0
	movw R16,R10
	xcall div16s
	movw R20,R16
	.dbline 942
; 	 numstrg[0] = '0' + hundreds;
	movw R24,R22
	adiw R24,48
	sts _numstrg,R24
	.dbline 943
; 	 numstrg[1] = '0' + tens;
	movw R24,R20
	adiw R24,48
	sts _numstrg+1,R24
	.dbline 944
; 	 numstrg[2] = '0' + intvalue%10; 
	ldi R18,10
	ldi R19,0
	movw R16,R10
	xcall mod16s
	movw R24,R16
	adiw R24,48
	sts _numstrg+2,R24
	.dbline 945
; 	 numstrg[3] = ' ';
	ldi R24,32
	sts _numstrg+3,R24
	.dbline 946
; 	 numstrg[4] = ' ';
	sts _numstrg+4,R24
	.dbline 947
; 	 numstrg[5] = 0x00;
	clr R2
	sts _numstrg+5,R2
	.dbline -2
L283:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym l tenthousands 1 I
	.dbsym r tens 20 I
	.dbsym r thousands 12 I
	.dbsym r hundreds 22 I
	.dbsym r intvalue 10 I
	.dbend
	.dbfunc e Float2strg _Float2strg fV
;   tenthousands -> <dead>
;           tens -> R20,R21
;       hundreds -> R22,R23
;      thousands -> R12,R13
;       intvalue -> R10,R11
	.even
_Float2strg::
	xcall push_xgsetF03C
	movw R10,R16
	.dbline -1
	.dbline 951
; }
; 
; void Float2strg(int intvalue)
; {
	.dbline 954
;  	 int  tenthousands, thousands, hundreds, tens;
; 
; 	 thousands = intvalue/1000;
	ldi R18,1000
	ldi R19,3
	movw R16,R10
	xcall div16s
	movw R12,R16
	.dbline 955
; 	 intvalue -= (thousands*1000);
	ldi R16,1000
	ldi R17,3
	movw R18,R12
	xcall empy16s
	sub R10,R16
	sbc R11,R17
	.dbline 956
; 	 hundreds = intvalue/100;
	ldi R18,100
	ldi R19,0
	movw R16,R10
	xcall div16s
	movw R22,R16
	.dbline 957
; 	 intvalue -= (hundreds*100);
	ldi R16,100
	ldi R17,0
	movw R18,R22
	xcall empy16s
	sub R10,R16
	sbc R11,R17
	.dbline 958
; 	 tens = intvalue/10;
	ldi R18,10
	ldi R19,0
	movw R16,R10
	xcall div16s
	movw R20,R16
	.dbline 959
; 	 numstrg[0] = '0' + thousands;
	movw R24,R12
	adiw R24,48
	sts _numstrg,R24
	.dbline 960
; 	 numstrg[1] = '.';
	ldi R24,46
	sts _numstrg+1,R24
	.dbline 961
; 	 numstrg[2] = '0' + hundreds;
	movw R24,R22
	adiw R24,48
	sts _numstrg+2,R24
	.dbline 962
; 	 numstrg[3] = '0' + tens;
	movw R24,R20
	adiw R24,48
	sts _numstrg+3,R24
	.dbline 963
; 	 numstrg[4] = '0' + intvalue%10; 
	ldi R18,10
	ldi R19,0
	movw R16,R10
	xcall mod16s
	movw R24,R16
	adiw R24,48
	sts _numstrg+4,R24
	.dbline 964
; 	 numstrg[5] = 0x00;
	clr R2
	sts _numstrg+5,R2
	.dbline -2
L289:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym l tenthousands 1 I
	.dbsym r tens 20 I
	.dbsym r hundreds 22 I
	.dbsym r thousands 12 I
	.dbsym r intvalue 10 I
	.dbend
	.dbfunc e Display_Voltage _Display_Voltage fV
;           tens -> <dead>
;       hundreds -> <dead>
;      thousands -> <dead>
;   tenthousands -> <dead>
;     newvoltvol -> <dead>
;           strg -> y+6
;        voltage -> y+2
;       intvalue -> R12,R13
;    analogvalue -> R12,R13
;         column -> R20
;            row -> R10
	.even
_Display_Voltage::
	xcall push_xgset303C
	mov R20,R18
	mov R10,R16
	sbiw R28,12
	.dbline -1
	.dbline 968
; }
; 
; void Display_Voltage(unsigned char row,unsigned char column)
; {
	.dbline 974
;  	 char strg[6];
;  	 int analogvalue,newvoltvol,intvalue;
;  	 int  tenthousands, thousands, hundreds, tens;
; 	 float voltage;
; 	 
; 	 PutStringinBuffer(row,column,"Voltage=");
	ldi R24,<L296
	ldi R25,>L296
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 975
;  	 analogvalue = Read_ADC(0);
	clr R16
	xcall _Read_ADC
	.dbline 976
; 	 voltage = (float) analogvalue/159.72;
	xcall int2fp
	movw R2,R16
	movw R4,R18
	ldi R16,<L297
	ldi R17,>L297
	xcall lpm32
	st -y,R19
	st -y,R18
	st -y,R17
	st -y,R16
	movw R16,R2
	movw R18,R4
	xcall fpdiv2
	std y+2,R16
	std y+3,R17
	std y+4,R18
	std y+5,R19
	.dbline 977
; 	 intvalue = voltage * 1000; // shift to 1000 2.234 becomes 2234
	ldi R16,<L298
	ldi R17,>L298
	xcall lpm32
	movw R24,R28
	adiw R24,2
	st -y,R25
	st -y,R24
	xcall fpmule1
	xcall fpint
	movw R12,R16
	.dbline 979
; 	 
; 	 Float2strg(intvalue);
	xcall _Float2strg
	.dbline 981
; 	 
; 	 PutStringinBuffer(row,column+8,numstrg);
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,248    ; addi 8
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L295:
	.dbline 0 ; func end
	adiw R28,12
	xjmp pop_xgset303C
	.dbsym l tens 3 I
	.dbsym l hundreds 3 I
	.dbsym l thousands 3 I
	.dbsym l tenthousands 3 I
	.dbsym l newvoltvol 3 I
	.dbsym l strg 6 A[6:6]c
	.dbsym l voltage 2 D
	.dbsym r intvalue 12 I
	.dbsym r analogvalue 12 I
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Display_Voltage_Reference _Display_Voltage_Reference fV
;     newvoltvol -> <dead>
;    analogvalue -> R22,R23
;           strg -> y+2
;         column -> R20
;            row -> R10
	.even
_Display_Voltage_Reference::
	xcall push_xgsetF00C
	mov R20,R18
	mov R10,R16
	sbiw R28,7
	.dbline -1
	.dbline 985
; }
; 
; void Display_Voltage_Reference(unsigned char row,unsigned char column)
; {
	.dbline 989
;  	 char strg[5];
;  	 int analogvalue,newvoltvol;
; 	 
; 	 PutStringinBuffer(row,column,"Analog0=");
	ldi R24,<L300
	ldi R25,>L300
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 990
;  	 analogvalue = Read_ADC(0);
	clr R16
	xcall _Read_ADC
	movw R22,R16
	.dbline 992
; 	  
; 	 bytetohex((analogvalue>>8)&0xff);
	mov R16,R17
	clr R17
	sbrc R16,7
	com R17
	andi R17,0
	xcall _bytetohex
	.dbline 993
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 994
; 	 bytetohex((analogvalue&0x00ff));
	mov R16,R22
	andi R17,0
	xcall _bytetohex
	.dbline 995
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 996
; 	 PutStringinBuffer(row,column+8,strg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,248    ; addi 8
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L299:
	.dbline 0 ; func end
	adiw R28,7
	xjmp pop_xgsetF00C
	.dbsym l newvoltvol 3 I
	.dbsym r analogvalue 22 I
	.dbsym l strg 2 A[5:5]c
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Adjust_VoltageVolume _Adjust_VoltageVolume fV
	.even
_Adjust_VoltageVolume::
	.dbline -1
	.dbline 1000
; }
; 
; void  Adjust_VoltageVolume()
; {
	.dbline 1001
; 	 if((voltagevolume=(1+(574-Read_ADC(0))/14))>0x0f) 
	clr R16
	xcall _Read_ADC
	movw R2,R16
	ldi R16,574
	ldi R17,2
	sub R16,R2
	sbc R17,R3
	ldi R18,14
	ldi R19,0
	xcall div16s
	movw R24,R16
	adiw R24,1
	mov R2,R24
	sts _voltagevolume,R2
	ldi R24,15
	cp R24,R2
	brsh L302
X142:
	.dbline 1002
; 	     voltagevolume = 0x0f;
	sts _voltagevolume,R24
L302:
	.dbline 1003
; 	 LCDwritecommand(LCDVOLREG|voltagevolume); 
	lds R16,_voltagevolume
	ori R16,112
	xcall _LCDwritecommand
	.dbline -2
L301:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayTime _DisplayTime fV
;           strg -> y+2
;         column -> R12
;            row -> R10
	.even
_DisplayTime::
	st -y,R10
	st -y,R12
	mov R12,R18
	mov R10,R16
	sbiw R28,11
	.dbline -1
	.dbline 1008
; }
; 
; 
; void DisplayTime(unsigned char row,unsigned char column)
; {
	.dbline 1012
;  	 char strg[9];
; 	 	
; 	 //PutStringinBuffer(column,"t=");
; 	 bytetoint(hours);
	lds R16,_hours
	xcall _bytetoint
	.dbline 1013
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 1014
; 	 strcat(strg,":");
	ldi R18,<L305
	ldi R19,>L305
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 1015
; 	 bytetoint(minutes);
	lds R16,_minutes
	xcall _bytetoint
	.dbline 1016
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 1017
; 	 strcat(strg,":");
	ldi R18,<L305
	ldi R19,>L305
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 1018
; 	 bytetoint(seconds);
	lds R16,_seconds
	xcall _bytetoint
	.dbline 1019
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 1020
; 	 PutStringinBuffer(row,column,strg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	mov R18,R12
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L304:
	.dbline 0 ; func end
	adiw R28,11
	ld R12,y+
	ld R10,y+
	ret
	.dbsym l strg 2 A[9:9]c
	.dbsym r column 12 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Display_Display_Parameters _Display_Display_Parameters fV
	.even
_Display_Display_Parameters::
	.dbline -1
	.dbline 1024
; }
; 
; void Display_Display_Parameters()
; {
	.dbline 1025
; 	if(flip2==ON) {
	lds R2,_flip2
	tst R2
	brne L307
X143:
	.dbline 1025
	.dbline 1028
; 		//LCD_Symbols(ON);
; 		//Display_Voltage_Reference(0,0);
; 		Display_Voltage(0,0);
	clr R18
	clr R16
	xcall _Display_Voltage
	.dbline 1029
; 		Display_Voltage_Reference(1,0);
	clr R18
	ldi R16,1
	xcall _Display_Voltage_Reference
	.dbline 1031
; 		//Display_Voltage_Volume(1,0);
; 		DisplayTime(3,0);
	clr R18
	ldi R16,3
	xcall _DisplayTime
	.dbline 1032
; 		LED_Power(OFF);
	ldi R16,1
	xcall _LED_Power
	.dbline 1034
; 		//LCD_LED_Power(ON);
; 		flip2 = YES;
	ldi R24,1
	sts _flip2,R24
	.dbline 1036
; 		//line4[11] = '.';
;     	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1037
; 		}
	xjmp L308
L307:
	.dbline 1038
; 	else {
	.dbline 1041
; 		//line4[11] = ' ';
; 		//LCD_Symbols(OFF);	
;     	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1043
; 		//LCD_LED_Power(OFF);
; 		LED_Power(ON);
	clr R16
	xcall _LED_Power
	.dbline 1044
; 		flip2 = NO;
	clr R2
	sts _flip2,R2
	.dbline 1045
; 		}
L308:
	.dbline 1046
; 	mseccountdown2 = 250;
	ldi R24,250
	ldi R25,0
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
	.dbline -2
L306:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Display_Count _Display_Count fV
;        outstrg -> y+2
	.even
_Display_Count::
	sbiw R28,14
	.dbline -1
	.dbline 1050
; }
; 
; void Display_Count()
; {
	.dbline 1053
;  	char outstrg[12];
; 	
; 	rtccountdown1 = 256;
	ldi R24,256
	ldi R25,1
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
	.dbline 1054
; 	bytetohex((count>>8)&0xff);
	lds R16,_count
	lds R17,_count+1
	mov R16,R17
	clr R17
	andi R17,0
	xcall _bytetohex
	.dbline 1055
; 	strcpy(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 1056
; 	bytetohex((count&0x00ff));
	lds R16,_count
	andi R17,0
	xcall _bytetohex
	.dbline 1057
; 	strcat(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 1058
; 	PutStringinBuffer(2,0,"count=");
	ldi R24,<L310
	ldi R25,>L310
	std y+1,R25
	std y+0,R24
	clr R18
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 1059
; 	PutStringinBuffer(2,6,outstrg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,6
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 1060
; 	count++;
	lds R24,_count
	lds R25,_count+1
	adiw R24,1
	sts _count+1,R25
	sts _count,R24
	.dbline -2
L309:
	.dbline 0 ; func end
	adiw R28,14
	ret
	.dbsym l outstrg 2 A[12:12]c
	.dbend
	.dbfunc e main _main fV
;        realnum -> y+18
;      voltlevel -> R10
;        outbyte -> R10
;      symbolptr -> R10
;    symbolindex -> R10,R11
;         level2 -> R10
;          level -> R10
; TWI_slaveAddress -> R22
;        outstrg -> y+6
;           flip -> R10
;        outchar -> R10
;         inchar -> R20
;       twichars -> R10
;     messageBuf -> y+2
;              i -> R20,R21
;    analogvalue -> R10,R11
	.even
_main::
	sbiw R28,22
	.dbline -1
	.dbline 1064
; }
; 
; void main()
; {
	.dbline 1071
;     unsigned char inchar,messageBuf[MESSAGEBUF_SIZE], TWI_slaveAddress;
; 	unsigned char symbolptr,level,level2,outbyte,voltlevel,outchar,twichars;
;     char flip,outstrg[12];
; 	int i,symbolindex,analogvalue;
; 	float realnum;
; 
; 	Init_AVR();
	xcall _Init_AVR
	.dbline 1072
;     Init_LCD();
	xcall _Init_LCD
	.dbline 1073
;     Clear_LCD();
	xcall _Clear_LCD
	.dbline 1075
; 	
; 	Adjust_VoltageVolume(); 
	xcall _Adjust_VoltageVolume
	.dbline 1078
; //   LCDtest();
;    
;     TWI_slaveAddress = TWI_SLAVEADDRESS;  // Set TWI slave address
	ldi R22,38
	.dbline 1080
; //    TWI_Slave_Initialise(TWI_slaveAddress,TWI_generalCall,TWI_mask);
;     TWI_Slave_Initialise(TWI_slaveAddress,0,0);
	clr R2
	std y+0,R2
	clr R18
	mov R16,R22
	xcall _TWI_Slave_Initialise
	.dbline 1081
; 	bytetohex(TWI_slaveAddress);
	mov R16,R22
	xcall _bytetohex
	.dbline 1082
; 	bytetohex(0x26);
	ldi R16,38
	xcall _bytetohex
	.dbline 1083
; 	strcpy(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _strcpy
	.dbline 1084
; 	PutStringinBuffer(3,6,outstrg);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	ldi R18,6
	ldi R16,3
	xcall _PutStringinBuffer
	.dbline 1088
; 
; //   load_eeprom_settings();  //load all start values in eeprom
; 
;     DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1089
;     rowptr = 4;
	ldi R24,4
	sts _rowptr,R24
	.dbline 1090
;     cursorposition = 12;
	ldi R24,12
	sts _cursorposition,R24
	.dbline 1091
;     lineptr = LINE4;
	ldi R24,96
	sts _lineptr,R24
	.dbline 1092
;     escmode = OFF;
	ldi R24,1
	sts _escmode,R24
	.dbline 1093
;     inchar = 0x31;
	ldi R20,49
	.dbline 1094
; 	flip = NO;
	.dbline 1095
; 	symbolindex = 0;
	clr R11
	.dbline 1096
; 	symbolptr = 0x00;
	.dbline 1097
; 	level2 = level = 1;
	.dbline 1098
; 	voltlevel = 0;
	.dbline 1099
; 	count = 0;
	clr R2
	clr R3
	sts _count+1,R3
	sts _count,R2
	.dbline 1100
; 	outchar = 0x30;
	.dbline 1101
;     LCD_Symbols(OFF);
	ldi R16,1
	xcall _LCD_Symbols
	.dbline 1104
; 	//LCD_Antenna(LCD_ANTENNA_FULL);
; 	//LCD_Battery(LCD_BATTERY_FULL);
; 	outbyte = 0;
	clr R10
	.dbline 1106
; 
; 	Adjust_VoltageVolume(); 
	xcall _Adjust_VoltageVolume
	.dbline 1107
; 	LoadSignon();
	xcall _LoadSignon
	.dbline 1108
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1109
; 	lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 1110
; 	cursorposition = 0;	
	clr R2
	sts _cursorposition,R2
	.dbline 1111
; 	Delaymsec(1000);
	ldi R16,1000
	ldi R17,3
	xcall _Delaymsec
	.dbline 1113
; 	
; 	Adjust_VoltageVolume(); 
	xcall _Adjust_VoltageVolume
	.dbline 1114
; 	LoadSignon();
	xcall _LoadSignon
	.dbline 1116
; 
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1117
; 	lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 1118
; 	cursorposition = 0;	
	clr R2
	sts _cursorposition,R2
	.dbline 1119
; 	Delaymsec(3000);
	ldi R16,3000
	ldi R17,11
	xcall _Delaymsec
	.dbline 1120
; 	Clear_LCD();
	xcall _Clear_LCD
	.dbline 1121
; 	Delaymsec(200);
	ldi R16,200
	ldi R17,0
	xcall _Delaymsec
	.dbline 1123
; 	
; 	LoadSignon2();
	xcall _LoadSignon2
	.dbline 1124
; 	bytetohex(TWI_slaveAddress);
	mov R16,R22
	xcall _bytetohex
	.dbline 1125
; 	strcpy(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,250  ; offset = 6
	sbci R17,255
	xcall _strcpy
	.dbline 1126
; 	PutStringinBuffer(1,10,outstrg);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	ldi R18,10
	ldi R16,1
	xcall _PutStringinBuffer
	.dbline 1127
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1128
; 	lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 1129
; 	cursorposition = 0;	
	clr R2
	sts _cursorposition,R2
	.dbline 1130
; 	Delaymsec(5000);
	ldi R16,5000
	ldi R17,19
	xcall _Delaymsec
	.dbline 1131
; 	Clear_LCD();
	xcall _Clear_LCD
	.dbline 1132
; 	Delaymsec(1000);
	ldi R16,1000
	ldi R17,3
	xcall _Delaymsec
	.dbline 1136
; 	
; 	//  Output signon message to UART - ESC c turns character
; 	//  display on
; 	putfs(signon1);
	ldi R16,<_signon1
	ldi R17,>_signon1
	xcall _putfs
	.dbline 1137
; 	putfs(signon11);
	ldi R16,<_signon11
	ldi R17,>_signon11
	xcall _putfs
	.dbline 1138
; 	putfs(signon12);
	ldi R16,<_signon12
	ldi R17,>_signon12
	xcall _putfs
	.dbline 1139
; 	PutStringinBuffer(3,10,outstrg);
	movw R24,R28
	adiw R24,6
	std y+1,R25
	std y+0,R24
	ldi R18,10
	ldi R16,3
	xcall _PutStringinBuffer
	xjmp L313
L312:
	.dbline 1142
; 	
; 	//  Monitor TWI and Uart ports for display data
; 	while(1) { 
	.dbline 1144
; 		
; 		LCD_LED_Power(OFF);
	ldi R16,1
	xcall _LCD_LED_Power
	.dbline 1147
; 		//LED_Power(OFF);
; 		
; 	    if(0) {
	xjmp L315
X144:
	.dbline 1148
; 	      if(mseccountdown1==0) {
	.dbline 1149
; 		    if(flip==NO) {
	tst R10
	brne L319
X145:
	.dbline 1149
	.dbline 1150
; 				if(symbolindex==0) {
	tst R10
	brne L321
	tst R11
	brne L321
X146:
	.dbline 1150
	.dbline 1151
; 					LCD_Envelope(ON);
	clr R16
	xcall _LCD_Envelope
	.dbline 1152
; 					LCD_Dsymbol(ON);
	clr R16
	xcall _LCD_Dsymbol
	.dbline 1153
; 					LCD_Rsymbol(ON);
	clr R16
	xcall _LCD_Rsymbol
	.dbline 1154
; 					LCD_Vsymbol(ON);
	clr R16
	xcall _LCD_Vsymbol
	.dbline 1155
; 					LCD_Phone(level2++);
	mov R2,R10
	mov R24,R2
	subi R24,255    ; addi 1
	mov R10,R24
	mov R16,R2
	xcall _LCD_Phone
	.dbline 1156
; 					LCD_Battery(level);
	mov R16,R10
	xcall _LCD_Battery
	.dbline 1157
; 					LCD_Antenna(level++);
	mov R2,R10
	mov R24,R2
	subi R24,255    ; addi 1
	mov R10,R24
	mov R16,R2
	xcall _LCD_Antenna
	.dbline 1158
; 					if(level==7) level = 1;
	mov R24,R10
	cpi R24,7
	brne L323
X147:
	.dbline 1158
	clr R10
	inc R10
L323:
	.dbline 1159
; 					if(level2==4) level2 = 1;
	mov R24,R10
	cpi R24,4
	brne L325
X148:
	.dbline 1159
	clr R10
	inc R10
L325:
	.dbline 1160
; 					}
L321:
	.dbline 1161
; 		        DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1162
; 				flip = YES;
	clr R10
	inc R10
	.dbline 1163
; 		        }
	xjmp L320
L319:
	.dbline 1164
; 		    else {
	.dbline 1165
; 				LCD_Envelope(OFF);
	ldi R16,1
	xcall _LCD_Envelope
	.dbline 1166
; 				LCD_Dsymbol(OFF);
	ldi R16,1
	xcall _LCD_Dsymbol
	.dbline 1167
; 				LCD_Rsymbol(OFF);
	ldi R16,1
	xcall _LCD_Rsymbol
	.dbline 1168
; 				LCD_Vsymbol(OFF);
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 1169
; 				DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1170
; 				flip = NO;
	clr R10
	.dbline 1171
; 			    }
L320:
	.dbline 1172
; 		    mseccountdown1 = 500;
	ldi R24,500
	ldi R25,1
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
	.dbline 1173
; 			}
L317:
	.dbline 1174
; 			}
L315:
	.dbline 1176
; 
; 		if((CheckKeyState(KEY3))&&(textdisplaymode==ACTIVE)) {
	ldi R16,3
	xcall _CheckKeyState
	mov R10,R16
	tst R16
	breq L327
X149:
	lds R24,_textdisplaymode
	cpi R24,97
	brne L327
X150:
	.dbline 1176
	.dbline 1177
; 		    textdisplaymode = INACTIVE;
	ldi R24,105
	sts _textdisplaymode,R24
	.dbline 1178
; 			}
L327:
	.dbline 1180
; 		
; 		if(mseccountdown4==0) {
	lds R2,_mseccountdown4
	lds R3,_mseccountdown4+1
	tst R2
	brne L329
	tst R3
	brne L329
X151:
	.dbline 1180
	.dbline 1181
; 		    Adjust_VoltageVolume();
	xcall _Adjust_VoltageVolume
	.dbline 1182
; 			mseccountdown4 = 1;
	ldi R24,1
	ldi R25,0
	sts _mseccountdown4+1,R25
	sts _mseccountdown4,R24
	.dbline 1183
; 			}
L329:
	.dbline 1185
; 		
; 		if(textdisplaymode==INACTIVE) {
	lds R24,_textdisplaymode
	cpi R24,105
	brne L331
X152:
	.dbline 1185
	.dbline 1186
; 		    if(rtccountdown1==0) Display_Count();
	lds R2,_rtccountdown1
	lds R3,_rtccountdown1+1
	tst R2
	brne L333
	tst R3
	brne L333
X153:
	.dbline 1186
	xcall _Display_Count
L333:
	.dbline 1188
; 			
; 		    if(mseccountdown2==0) Display_Display_Parameters();
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L335
	tst R3
	brne L335
X154:
	.dbline 1188
	xcall _Display_Display_Parameters
L335:
	.dbline 1190
; 		   
; 		    if(0) {
	xjmp L337
X155:
	.dbline 1193
; 		        //if(mseccountdown3==0) {
; 		        SendCharToDisplay(outchar++);
; 		        if(outchar>0x7a) outchar = 0x30;
	ldi R24,48
	mov R10,R24
L339:
	.dbline 1194
; 		        mseccountdown3 = 50;
	ldi R24,50
	ldi R25,0
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
	.dbline 1195
; 		        }
L337:
	.dbline 1196
; 			}
L331:
	.dbline 1198
;    
;    		if(textdisplaymode==INACTIVE) {
	lds R24,_textdisplaymode
	cpi R24,105
	breq X167
	xjmp L341
X167:
X156:
	.dbline 1198
	.dbline 1199
; 		    if(CheckKeyState(KEY1)) {
	ldi R16,1
	xcall _CheckKeyState
	mov R10,R16
	tst R16
	brne X168
	xjmp L343
X168:
X157:
	.dbline 1199
	xjmp L346
L345:
	.dbline 1202
; 			    // Display 3-axis acceleration
; 				
; 			    while(CheckKeyState(KEY1)) {
	.dbline 1203
; 				    enableAccelerometer(ON);
	clr R16
	xcall _enableAccelerometer
	.dbline 1204
; 				    setAccelerometerRange(ACCELEROMETER_1g5_SENSITIVITY);
	ldi R16,32
	xcall _setAccelerometerRange
	.dbline 1205
; 					analogvalue = readAccelerometer(X_AXIS);
	clr R16
	xcall _readAccelerometer
	.dbline 1206
; 					Int2strg(analogvalue);
	xcall _Int2strg
	.dbline 1207
; 					PutStringinBuffer(0,0,"X Axis=");
	ldi R24,<L348
	ldi R25,>L348
	std y+1,R25
	std y+0,R24
	clr R18
	clr R16
	xcall _PutStringinBuffer
	.dbline 1208
; 					PutStringinBuffer(0,7,numstrg);
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	std y+1,R25
	std y+0,R24
	ldi R18,7
	clr R16
	xcall _PutStringinBuffer
	.dbline 1209
; 				    analogvalue = readAccelerometer(Y_AXIS);
	ldi R16,1
	xcall _readAccelerometer
	.dbline 1210
; 					Int2strg(analogvalue);
	xcall _Int2strg
	.dbline 1211
; 					PutStringinBuffer(1,0,"Y Axis=");
	ldi R24,<L349
	ldi R25,>L349
	std y+1,R25
	std y+0,R24
	clr R18
	ldi R16,1
	xcall _PutStringinBuffer
	.dbline 1212
; 					PutStringinBuffer(1,7,numstrg);
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	std y+1,R25
	std y+0,R24
	ldi R18,7
	ldi R16,1
	xcall _PutStringinBuffer
	.dbline 1213
; 				    analogvalue = readAccelerometer(Z_AXIS);
	ldi R16,2
	xcall _readAccelerometer
	movw R12,R16
	movw R10,R12
	.dbline 1214
; 					Int2strg(analogvalue);
	xcall _Int2strg
	.dbline 1215
; 					PutStringinBuffer(2,0,"Z Axis=");
	ldi R24,<L350
	ldi R25,>L350
	std y+1,R25
	std y+0,R24
	clr R18
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 1216
; 					PutStringinBuffer(2,7,numstrg);
	ldi R24,<_numstrg
	ldi R25,>_numstrg
	std y+1,R25
	std y+0,R24
	ldi R18,7
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 1217
; 				    line4[8] = 'p';
	ldi R24,112
	sts _line4+8,R24
	.dbline 1218
; 					DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1219
; 				    }
L346:
	.dbline 1202
	ldi R16,1
	xcall _CheckKeyState
	mov R10,R16
	tst R16
	breq X169
	xjmp L345
X169:
X158:
	.dbline 1220
; 				LCD_Symbols(OFF);
	ldi R16,1
	xcall _LCD_Symbols
	.dbline 1221
; 				Clear_LCD();
	xcall _Clear_LCD
	.dbline 1222
; 				}
	xjmp L344
L343:
	.dbline 1223
; 			else line4[8] = ' ';
	ldi R24,32
	sts _line4+8,R24
L344:
	.dbline 1224
; 			if(CheckKeyState(KEY2)) line4[9] = 'p';
	ldi R16,2
	xcall _CheckKeyState
	mov R10,R16
	tst R16
	breq L353
X159:
	.dbline 1224
	ldi R24,112
	sts _line4+9,R24
	xjmp L354
L353:
	.dbline 1225
; 			else line4[9] = ' ';
	ldi R24,32
	sts _line4+9,R24
L354:
	.dbline 1226
; 			if(CheckKeyState(KEY3)) {
	ldi R16,3
	xcall _CheckKeyState
	mov R10,R16
	tst R16
	breq L357
X160:
	.dbline 1226
	.dbline 1227
; 				if(lcdledpower==ON) {
	lds R2,_lcdledpower
	tst R2
	brne L359
X161:
	.dbline 1227
	.dbline 1228
; 				    LCD_LED_Power(OFF);
	ldi R16,1
	xcall _LCD_LED_Power
	.dbline 1229
; 					lcdledpower = OFF;
	ldi R24,1
	sts _lcdledpower,R24
	.dbline 1230
; 					}
	xjmp L360
L359:
	.dbline 1231
; 				else {
	.dbline 1232
; 				    LCD_LED_Power(ON);
	clr R16
	xcall _LCD_LED_Power
	.dbline 1233
; 					lcdledpower = ON;
	clr R2
	sts _lcdledpower,R2
	.dbline 1234
; 				    }
L360:
	.dbline 1235
; 			    line4[10] = 'p';
	ldi R24,112
	sts _line4+10,R24
	.dbline 1236
; 				}
	xjmp L358
L357:
	.dbline 1237
; 			else line4[10] = ' ';
	ldi R24,32
	sts _line4+10,R24
L358:
	.dbline 1238
; 			if(CheckKeyState(KEY4)) {
	ldi R16,4
	xcall _CheckKeyState
	mov R10,R16
	tst R16
	breq L363
X162:
	.dbline 1238
	.dbline 1239
; 			    line4[11] = 'p';
	ldi R24,112
	sts _line4+11,R24
	.dbline 1240
; 			    LoadSignon3();
	xcall _LoadSignon3
	.dbline 1241
; 			    DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1242
; 			    Delaymsec(3000);
	ldi R16,3000
	ldi R17,11
	xcall _Delaymsec
	.dbline 1243
; 			    lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 1244
; 			    cursorposition = 0;	
	clr R2
	sts _cursorposition,R2
	.dbline 1245
; 			    Clear_LCD();
	xcall _Clear_LCD
	.dbline 1246
; 				ParseChar(ESC);
	ldi R16,27
	xcall _ParseChar
	.dbline 1247
; 				ParseChar('c');
	ldi R16,99
	xcall _ParseChar
	.dbline 1248
; 				}
	xjmp L364
L363:
	.dbline 1249
; 			else line4[11] = ' ';
	ldi R24,32
	sts _line4+11,R24
L364:
	.dbline 1250
; 		}
L341:
	.dbline 1253
; 		   
; 		//  Check Uart RX for display commands
; 		if((inchar=getcharnw())!=0)  {
	xcall _getcharnw
	mov R10,R16
	mov R20,R10
	tst R16
	breq L367
X163:
	.dbline 1253
	.dbline 1254
; 		    ParseChar(inchar);
	xcall _ParseChar
	.dbline 1255
; 			putchar(inchar);
	mov R16,R20
	clr R17
	xcall _putchar
	.dbline 1256
; 			}
L367:
	.dbline 1259
; 		
; 		//  Check TWI Input for display commands
; 	    if(1) {
	.dbline 1259
	.dbline 1261
; 		    // See if any data arrived on TWI
; 			if((twichars=TWI_Get_Data_From_Transceiver(messageBuf,4))>0) {
	ldi R18,4
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _TWI_Get_Data_From_Transceiver
	mov R12,R16
	mov R10,R12
	ldi R24,0
	cp R24,R16
	brsh L371
X164:
	.dbline 1261
	.dbline 1262
; 			    for(i=0; i<twichars; i++) ParseChar(messageBuf[i]);
	clr R20
	clr R21
	xjmp L376
L373:
	.dbline 1262
	movw R24,R28
	adiw R24,2
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _ParseChar
L374:
	.dbline 1262
	subi R20,255  ; offset = 1
	sbci R21,255
L376:
	.dbline 1262
	mov R2,R10
	clr R3
	cp R20,R2
	cpc R21,R3
	brlt L373
X165:
	.dbline 1263
; 			    }
L371:
	.dbline 1264
; 	         }
L369:
	.dbline 1265
; 	    }
L313:
	.dbline 1142
	xjmp L312
X166:
	.dbline -2
L311:
	.dbline 0 ; func end
	adiw R28,22
	ret
	.dbsym l realnum 18 D
	.dbsym r voltlevel 10 c
	.dbsym r outbyte 10 c
	.dbsym r symbolptr 10 c
	.dbsym r symbolindex 10 I
	.dbsym r level2 10 c
	.dbsym r level 10 c
	.dbsym r TWI_slaveAddress 22 c
	.dbsym l outstrg 6 A[12:12]c
	.dbsym r flip 10 c
	.dbsym r outchar 10 c
	.dbsym r inchar 20 c
	.dbsym r twichars 10 c
	.dbsym l messageBuf 2 A[4:4]c
	.dbsym r i 20 I
	.dbsym r analogvalue 10 I
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
_symbolmode::
	.blkb 1
	.dbsym e symbolmode _symbolmode c
_lcdphoneantennasymbols::
	.blkb 1
	.dbsym e lcdphoneantennasymbols _lcdphoneantennasymbols c
_escmode::
	.blkb 1
	.dbsym e escmode _escmode c
_lineptr::
	.blkb 1
	.dbsym e lineptr _lineptr c
_colptr::
	.blkb 1
	.dbsym e colptr _colptr c
_rowptr::
	.blkb 1
	.dbsym e rowptr _rowptr c
_cursormax::
	.blkb 1
	.dbsym e cursormax _cursormax c
_cursorposition::
	.blkb 1
	.dbsym e cursorposition _cursorposition c
_line4::
	.blkb 13
	.dbsym e line4 _line4 A[13:13]c
_line3::
	.blkb 13
	.dbsym e line3 _line3 A[13:13]c
_line2::
	.blkb 13
	.dbsym e line2 _line2 A[13:13]c
_line1::
	.blkb 13
	.dbsym e line1 _line1 A[13:13]c
_flip2::
	.blkb 1
	.dbsym e flip2 _flip2 c
_lcdstate::
	.blkb 1
	.dbsym e lcdstate _lcdstate c
_lcdchiptype::
	.blkb 1
	.dbsym e lcdchiptype _lcdchiptype c
_numstrg::
	.blkb 9
	.dbsym e numstrg _numstrg A[9:9]c
_count::
	.blkb 2
	.dbsym e count _count i
_totalrxcnt::
	.blkb 2
	.dbsym e totalrxcnt _totalrxcnt i
_oldbyteoffset::
	.blkb 2
	.dbsym e oldbyteoffset _oldbyteoffset i
_oldpage::
	.blkb 2
	.dbsym e oldpage _oldpage i
_intelsuperaddress::
	.blkb 2
	.dbsym e intelsuperaddress _intelsuperaddress i
_FlashAddress::
	.blkb 3
	.dbsym e FlashAddress _FlashAddress A[3:3]c
_hexbyte::
	.blkb 3
	.dbsym e hexbyte _hexbyte A[3:3]c
_vhigh::
	.blkb 1
	.dbsym e vhigh _vhigh c
_vlow::
	.blkb 1
	.dbsym e vlow _vlow c
_instrg::
	.blkb 8
	.dbsym e instrg _instrg A[8:8]c
_rxcntmax::
	.blkb 1
	.dbsym e rxcntmax _rxcntmax c
_checkflag::
	.blkb 1
	.dbsym e checkflag _checkflag c
_rxcnt::
	.blkb 1
	.dbsym e rxcnt _rxcnt c
_sendxoff::
	.blkb 1
	.dbsym e sendxoff _sendxoff c
_echoinchars::
	.blkb 1
	.dbsym e echoinchars _echoinchars c
_enablexonoff::
	.blkb 1
	.dbsym e enablexonoff _enablexonoff c
_xonsent::
	.blkb 1
	.dbsym e xonsent _xonsent c
_xoffsent::
	.blkb 1
	.dbsym e xoffsent _xoffsent c
_UART_TxTail::
	.blkb 1
	.dbsym e UART_TxTail _UART_TxTail c
_UART_TxHead::
	.blkb 1
	.dbsym e UART_TxHead _UART_TxHead c
_UART_TxBuf::
	.blkb 64
	.dbsym e UART_TxBuf _UART_TxBuf A[64:64]c
_UART_RxTail::
	.blkb 1
	.dbsym e UART_RxTail _UART_RxTail c
_UART_RxHead::
	.blkb 1
	.dbsym e UART_RxHead _UART_RxHead c
_UART_RxBuf::
	.blkb 64
	.dbsym e UART_RxBuf _UART_RxBuf A[64:64]c
_lcdledpower::
	.blkb 1
	.dbsym e lcdledpower _lcdledpower c
_textdisplaymode::
	.blkb 1
	.dbsym e textdisplaymode _textdisplaymode c
_rtcclockcnt::
	.blkb 1
	.dbsym e rtcclockcnt _rtcclockcnt c
_voltagevolume::
	.blkb 1
	.dbsym e voltagevolume _voltagevolume c
_dataoverrun::
	.blkb 1
	.dbsym e dataoverrun _dataoverrun c
_frameerror::
	.blkb 1
	.dbsym e frameerror _frameerror c
_xoffcnt::
	.blkb 2
	.dbsym e xoffcnt _xoffcnt i
_xoncnt::
	.blkb 2
	.dbsym e xoncnt _xoncnt i
_totalbytecnt::
	.blkb 2
	.dbsym e totalbytecnt _totalbytecnt i
_days::
	.blkb 2
	.dbsym e days _days i
_hours::
	.blkb 2
	.dbsym e hours _hours i
_minutes::
	.blkb 2
	.dbsym e minutes _minutes i
_seconds::
	.blkb 2
	.dbsym e seconds _seconds i
_mseccountdown4::
	.blkb 2
	.dbsym e mseccountdown4 _mseccountdown4 i
_mseccountdown3::
	.blkb 2
	.dbsym e mseccountdown3 _mseccountdown3 i
_mseccountdown2::
	.blkb 2
	.dbsym e mseccountdown2 _mseccountdown2 i
_mseccountdown1::
	.blkb 2
	.dbsym e mseccountdown1 _mseccountdown1 i
_rtccountdown4::
	.blkb 2
	.dbsym e rtccountdown4 _rtccountdown4 i
_rtccountdown3::
	.blkb 2
	.dbsym e rtccountdown3 _rtccountdown3 i
_rtccountdown2::
	.blkb 2
	.dbsym e rtccountdown2 _rtccountdown2 i
_rtccountdown1::
	.blkb 2
	.dbsym e rtccountdown1 _rtccountdown1 i
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L350:
	.blkb 8
	.area idata
	.byte 'Z,32,'A,'x,'i,'s,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L349:
	.blkb 8
	.area idata
	.byte 'Y,32,'A,'x,'i,'s,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L348:
	.blkb 8
	.area idata
	.byte 'X,32,'A,'x,'i,'s,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L310:
	.blkb 7
	.area idata
	.byte 'c,'o,'u,'n,'t,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L305:
	.blkb 2
	.area idata
	.byte 58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L300:
	.blkb 9
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,48,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
	.area lit(rom, con, rel)
L298:
	.word 0x0,0x447a
L297:
	.word 0xb852,0x431f
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L296:
	.blkb 9
	.area idata
	.byte 'V,'o,'l,'t,'a,'g,'e,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
L282:
	.blkb 8
	.area idata
	.byte 'V,'o,'l,'t,32,'v,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_Controller.c
; }
