	.module SmartLCD_TWI.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SMARTL~1\SMARTL~1.88\SmartLCD_TWI.c
	.dbfunc e Init_TWI_Master _Init_TWI_Master fV
	.even
_Init_TWI_Master::
	.dbline -1
	.dbline 72
; /**************************************************************
; 
;    Program Title:  SmartLCD Controller
;    
;    Program Name:  SmartLCD_TWI.c	Version: 0.85
;    
;    Author:  SS	  			    Date:  August 10, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.13A
;    
;    This file contains routines that implement a TWI Master and Slave
;    interrupt driven controller.
;    
;    Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;   
; ****************************************************************/
; /*
;  * Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: SmartLCD_TWI.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; //#include <stdlib.h>
; //#include <stdio.h>
; #include "SmartLCD_Uart.h"
; #include "SmartLCD_Defines.h"
; #include "SmartLCD_Extern.h"
; 
; // Initialize the TWI Master interface I2C
; //  TBD - pull the default slave address from EEPROM
; //        otherwise use default
; void  Init_TWI_Master(void)
; {
	.dbline 73
;  	  TWBR = 2;  // Set bit rate to about 100K with 8MHz clock
	ldi R24,2
	sts 184,R24
	.dbline 74
; 	  TWCR = (1<<TWINT)|(1<<TWEN);  // Turn 2 wire port on  SDA - PC1, SCL - PC0
	ldi R24,132
	sts 188,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_TWI_Slave _Init_TWI_Slave fV
;    generalcall -> R18
;   slaveaddress -> R16
	.even
_Init_TWI_Slave::
	.dbline -1
	.dbline 80
; }
; 
; // Initialize the TWI Slave interface I2C
; //  Set TWI slave address and optionally General Call
; void  Init_TWI_Slave(unsigned char slaveaddress,char generalcall)
; {
	.dbline 81
;  	  if(generalcall) TWAR = (slaveaddress<<1) | TWGCE;
	tst R18
	breq L3
X0:
	.dbline 81
	mov R2,R16
	lsl R2
	sts 186,R2
	xjmp L4
L3:
	.dbline 82
; 	  else TWAR = (slaveaddress<<1);
	mov R2,R16
	lsl R2
	sts 186,R2
L4:
	.dbline 85
; 	  // Turn 2 wire port on, enable slave address recognition,
; 	  // clear TWINT bit -  SDA - PC1, SCL - PC0
; 	  TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN);  
	ldi R24,196
	sts 188,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbsym r generalcall 18 c
	.dbsym r slaveaddress 16 c
	.dbend
	.dbfunc e TWI_Error _TWI_Error fV
	.even
_TWI_Error::
	.dbline -1
	.dbline 89
; }
; 
; void TWI_Error(void)
; {
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Off _TWI_Off fV
	.even
_TWI_Off::
	.dbline -1
	.dbline 93
; }
; 
; void TWI_Off(void)
; {
	.dbline 94
;  	 TWCR = (1<<TWINT);  // Reset TWI - this allows SDA to go high
	ldi R24,128
	sts 188,R24
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Transmit _TWI_Transmit fc
;   countervalue -> R12,R13
;     twistatus3 -> R10
;     twistatus2 -> R12
;     twistatus1 -> R14
;     statusmode -> y+10
;         txdata -> R18
;   slaveaddress -> R16
	.even
_TWI_Transmit::
	xcall push_xgsetF0FC
	.dbline -1
	.dbline 100
; }
; 
; // Transmit one byte to slave processor via 2-wire interface
; unsigned char  TWI_Transmit(unsigned char slaveaddress, unsigned char txdata,
;                             unsigned char statusmode)
; {
	.dbline 104
;       unsigned char twistatus1,twistatus2,twistatus3;
; 	  int countervalue;
; 	  
; 	  twistatus1=twistatus2=twistatus3 = 0;
	clr R10
	clr R12
	clr R14
	.dbline 107
; 
; 	  // Send start command and wait for completion
; 	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTA);
	ldi R24,164
	sts 188,R24
L8:
	.dbline 108
; 	  while(!(TWCR & (1<<TWINT)))  ;	
L9:
	.dbline 108
	lds R2,188
	sbrs R2,7
	rjmp L8
X1:
	.dbline 109
; 	  twistatus1 = TWSR;
	lds R14,185
	.dbline 111
; 	  // Send slave address and write command 
; 	  TWDR = (slaveaddress<<1) | SLA_W;
	mov R2,R16
	lsl R2
	sts 187,R2
	.dbline 112
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
	ldi R24,132
	sts 188,R24
L11:
	.dbline 113
; 	  while(!(TWCR & (1<<TWINT)))  ;  
L12:
	.dbline 113
	lds R2,188
	sbrs R2,7
	rjmp L11
X2:
	.dbline 114
; 	  twistatus2 = TWSR; 
	.dbline 116
; 	  // Send data byte and wait for transmission to complete
; 	  TWDR = txdata;    
	sts 187,R18
	.dbline 117
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
	ldi R24,132
	sts 188,R24
	.dbline 118
; 	  countervalue = 0;
	clr R12
	clr R13
L14:
	.dbline 119
; 	  while(!(TWCR & (1<<TWINT))) {
	.dbline 121
; //		  if(countervalue++>90) break;
; 		  } 	 
L15:
	.dbline 119
	lds R2,188
	sbrs R2,7
	rjmp L14
X3:
	.dbline 122
; 	  twistatus3 = TWSR;
	lds R10,185
	.dbline 132
; /*	  // Send second data byte and wait for transmission to complete
; 	  TWDR = 0x45;    
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
; 	  countervalue = 0;
; 	  while(!(TWCR & (1<<TWINT))) {
; 		  if(countervalue++>40) break;
; 		  } 	 
; 	  twistatus3 = TWSR;
; */
; 	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); 
	ldi R24,148
	sts 188,R24
	.dbline 134
; 	  // Optionally output status bytes
; 	  if((txdata!=0x55)&(statusmode==VERBOSE)) 
	cpi R18,85
	breq L19
X4:
	ldi R22,1
	ldi R23,0
	xjmp L20
L19:
	clr R22
	clr R23
L20:
	ldd R24,y+10
	cpi R24,2
	brne L21
X5:
	ldi R20,1
	ldi R21,0
	xjmp L22
L21:
	clr R20
	clr R21
L22:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X6
	tst R3
	breq L17
X6:
	.dbline 141
; 	  //printf("\nTWI status bytes = %x %x %x",twistatus1,twistatus2,twistatus3); 
; 	  
; 	  // Send stop command
; //	  if(countervalue>90) return 0x02;
; //	  else TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); 
; 
; 	  return 0x01;  // OK
	ldi R16,1
L17:
	.dbline -2
L7:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
	.dbsym r countervalue 12 I
	.dbsym r twistatus3 10 c
	.dbsym r twistatus2 12 c
	.dbsym r twistatus1 14 c
	.dbsym l statusmode 10 c
	.dbsym r txdata 18 c
	.dbsym r slaveaddress 16 c
	.dbend
	.dbfunc e TWI_Master_Receive _TWI_Master_Receive fc
;         rxdata -> R10
;   slaveaddress -> R12
	.even
_TWI_Master_Receive::
	st -y,R10
	st -y,R12
	mov R12,R16
	.dbline -1
	.dbline 146
; }
; 
; // Receive one byte from slave processor via 2-wire interface
; unsigned char TWI_Master_Receive(unsigned char slaveaddress)
; {
	.dbline 149
;  	  unsigned char rxdata;
; 	  
; 	  rxdata = 0;
	clr R10
	.dbline 150
;  	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTA);  // Send start condition
	ldi R24,164
	sts 188,R24
L24:
	.dbline 151
; 	  while(!(TWCR & (1<<TWINT)))  ;	  // Wait for TWINT flag - start done
L25:
	.dbline 151
	lds R2,188
	sbrs R2,7
	rjmp L24
X7:
	.dbline 153
; 	  //if((TWSR & 0xF8) != TWI_START) twi_error();  // See if Start condition
; 	  TWDR = (slaveaddress<<1) | SLA_R;	 // Request data command
	mov R24,R12
	lsl R24
	ori R24,1
	sts 187,R24
	.dbline 154
; 	  TWCR = (1<<TWINT)|(1<<TWEN);		  
	ldi R24,132
	sts 188,R24
L27:
	.dbline 155
; 	  while(!(TWCR & (1<<TWINT)))  ;	  // Wait for ACK/NACK 
L28:
	.dbline 155
	lds R2,188
	sbrs R2,7
	rjmp L27
X8:
	.dbline 156
; 	  if((TWSR & 0xF8) != MT_SLA_ACK) TWI_Error();  // See if ACK/NACK received  
	lds R24,185
	andi R24,248
	cpi R24,24
	breq L30
X9:
	.dbline 156
	xcall _TWI_Error
L30:
	.dbline 158
; 
; 	  TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN);
	ldi R24,196
	sts 188,R24
L32:
	.dbline 159
; 	  while(!(TWCR & (1<<TWINT)))  ; 	  // Wait for reception to complete
L33:
	.dbline 159
	lds R2,188
	sbrs R2,7
	rjmp L32
X10:
	.dbline 160
; 	  rxdata = TWDR;      			  	  // Send data byte 
	lds R10,187
	.dbline 174
; 	  
; 	  // Get next receive byte
; 	  /*
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
; 	  countervalue = 0;
; 	  while(!(TWCR & (1<<TWINT))) {
; 		 if(countervalue++>40) break;
; 		 } 	
; 	  inbyte = TWDR;    
; 	  twistatus4 = TWSR;
; 	  */
; 	  
; 	  //if((TWSR & 0xF8) != MT_DATA_ACK) TWI_Error();  // See if data received
; 	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);   // transmit stop
	ldi R24,148
	sts 188,R24
	.dbline 175
; 	  return rxdata;
	mov R16,R10
	.dbline -2
L23:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r rxdata 10 c
	.dbsym r slaveaddress 12 c
	.dbend
	.dbfunc e TestTWI _TestTWI fV
	.even
_TestTWI::
	sbiw R28,1
	.dbline -1
	.dbline 179
; }
; 								
; void  TestTWI(void)
; {
	.dbline 180
; 	TWI_Transmit(0x15,0x55,QUIET);
	ldi R24,1
	std y+0,R24
	ldi R18,85
	ldi R16,21
	xcall _TWI_Transmit
	.dbline 181
; 	TWI_Transmit(0x15,0xaa,QUIET);
	ldi R24,1
	std y+0,R24
	ldi R18,170
	ldi R16,21
	xcall _TWI_Transmit
	.dbline -2
L35:
	.dbline 0 ; func end
	adiw R28,1
	ret
	.dbend
	.dbfunc e TWI_Write_Slave _TWI_Write_Slave fV
;     twistatus3 -> <dead>
;     twistatus2 -> <dead>
;     twistatus1 -> <dead>
;   countervalue -> R10,R11
;         inchar -> R20
	.even
_TWI_Write_Slave::
	xcall push_xgsetF00C
	sbiw R28,1
	.dbline -1
	.dbline 185
; }
; 
; void TWI_Write_Slave()
; {
	.dbline 190
;     unsigned char inchar,twistatus1,twistatus2,twistatus3;
; 	int countervalue;
; 	
;     //printf(" TWI Master Write Active\n");
; 	Init_TWI_Master();
	xcall _Init_TWI_Master
	xjmp L38
L37:
	.dbline 192
; 	//printf("Enter character ['e'-exit z-sumo1]: ");
; 	while((inchar=getchar())!='e')  {
	.dbline 193
; 	    countervalue = 0;
	clr R10
	clr R11
	.dbline 194
; 		putchar(inchar);
	mov R16,R20
	clr R17
	xcall _putchar
	.dbline 196
; 		// Output byte on TWI continuously
; 		if(inchar=='z') {
	cpi R20,122
	brne L40
X11:
	.dbline 196
	.dbline 198
; 			//printf("Press 'e' to exit");
; 			}
L40:
	.dbline 199
; 		if(inchar=='r') {
	cpi R20,114
	brne L42
X12:
	.dbline 199
	xjmp L45
L44:
	.dbline 200
; 		    while(!(inchar=getcharnw()))  {
	.dbline 201
; 			    if(TWI_Transmit(0x15,0x55,VERBOSE)!=0x01) {
	ldi R24,2
	std y+0,R24
	ldi R18,85
	ldi R16,21
	xcall _TWI_Transmit
	cpi R16,1
	breq L47
X13:
	.dbline 201
	.dbline 202
; 		            TWI_Off();
	xcall _TWI_Off
	.dbline 203
; 		            Init_TWI_Master();
	xcall _Init_TWI_Master
	.dbline 204
; 		            }
L47:
	.dbline 205
; 			    }
L45:
	.dbline 200
	xcall _getcharnw
	mov R20,R16
	tst R20
	breq L44
X14:
	.dbline 206
; 			}
	xjmp L43
L42:
	.dbline 207
; 		else {
	.dbline 208
; 		    if(TWI_Transmit(0x15,inchar,VERBOSE)!=0x01) {
	ldi R24,2
	std y+0,R24
	mov R18,R20
	ldi R16,21
	xcall _TWI_Transmit
	mov R22,R16
	cpi R16,1
	breq L49
X15:
	.dbline 208
	.dbline 209
; 		        TWI_Off();
	xcall _TWI_Off
	.dbline 210
; 		        Init_TWI_Master();
	xcall _Init_TWI_Master
	.dbline 211
; 		        }
L49:
	.dbline 212
; 			}
L43:
	.dbline 214
;         //printf("\nEnter character('e' to exit): ");
; 	    }
L38:
	.dbline 192
	xcall _getchar
	movw R10,R16
	mov R22,R10
	mov R20,R22
	cpi R16,101
	brne L37
X16:
	.dbline 215
; 	TWI_Off();
	xcall _TWI_Off
	.dbline -2
L36:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgsetF00C
	.dbsym l twistatus3 2 c
	.dbsym l twistatus2 2 c
	.dbsym l twistatus1 2 c
	.dbsym r countervalue 10 I
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e TWI_Start_Transceiver_With_Data _TWI_Start_Transceiver_With_Data fc
;         inchar -> R1
;         instrg -> R0,R1
	.even
_TWI_Start_Transceiver_With_Data::
	.dbline -1
	.dbline 221
; 	//printf("\n");
; }
; 
; unsigned char TWI_Start_Transceiver_With_Data(unsigned char *instrg,
; 		 	  									  unsigned char inchar)
; {
	.dbline -2
L51:
	.dbline 0 ; func end
	ret
	.dbsym l inchar 2 c
	.dbsym l instrg 0 pc
	.dbend
	.dbfunc e TWI_Get_Data_From_Transceiver _TWI_Get_Data_From_Transceiver fc
;         inchar -> R1
;         instrg -> R0,R1
	.even
_TWI_Get_Data_From_Transceiver::
	.dbline -1
	.dbline 227
; 
; }
; 												  
; unsigned char TWI_Get_Data_From_Transceiver(unsigned char *instrg,
; 		 	  									unsigned char inchar)
; {
	.dbline -2
L52:
	.dbline 0 ; func end
	ret
	.dbsym l inchar 2 c
	.dbsym l instrg 0 pc
	.dbend
; 
; }
