	.module TWI_slave.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
_TWI_txDataInBuffer:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
	.dbsym s TWI_txDataInBuffer _TWI_txDataInBuffer c
_TWI_state:
	.blkb 1
	.area idata
	.byte 248
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
	.dbsym s TWI_state _TWI_state c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
	.dbfunc e TWI_Slave_Initialise _TWI_Slave_Initialise fV
;           mask -> y+0
;    generalCall -> R18
; TWI_ownAddress -> R16
	.even
_TWI_Slave_Initialise::
	.dbline -1
	.dbline 106
; /*
;  *
;  * SOC Robotics, Inc
;  *
;  * File - TWI_slave.c
;  *
;  * Compiler - ICCAVR 7.16a
;  * 
;  *
;  * Descrition:
;  *	This TWI module implements an interupt driven TWI device driver.
;  * 
;  * 	This Module is based on Atmel's application note AVR311
;  *
;  * Revision: 1.01 -> Date: November 5th, 2008				BR
;  *	>	Added TWI_DEFAULT_ADDRESS	
;  *	>	Modified TWI_Get_Data_From_Transceiver(...) so that it would not block
;  *		when you try to get data from the TWI
;  *	>	Modified the code so that we only disabled TWI interrupts when we copy
;  *		data from its buffers				
;  *	>	Modified TWI_SRX_GEN_DATA_ACK case statement in the TWI interrupt as it had an error
;  *	>	Changed TWI_RX_BUF_INDEX to TWI_rx_buf_index
;  *
;  *
;  *
;  * History:
;  * 
;  * Revision: 1.0 -> Date: October 23rd, 2008
;  *		Original											BR
;  *
;  * Copyright 2008, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC Robotics, Inc. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com/
;  */
; 
; #include <stdio.h>
; #include <iom168v.h>
; #include <macros.h>
; #include "TWI_slave.h"
; 
; #if defined(TWI_TIMER)
; #include "Timer.h"
; #endif
; 
; 
; #if defined(DEBUG)
; #include "Serial.h"
; #include "Utilities.h"
; unsigned char text[20];
; #endif
; 
; // TX buffer. Size set in the header file
; static unsigned char TWI_TX_BUF[TWI_TX_BUFFER_SIZE];
; static unsigned char TWI_txDataInBuffer = 0;// Number of bytes to be transmitted.
; 
; // RX buffer. Size set in the header file
; static unsigned char TWI_RX_BUF[TWI_RX_BUFFER_SIZE];
; static unsigned char TWI_rx_buf_index;// Number of bytes received.
; 
; // State byte. Default set to TWI_NO_STATE.                  
; static unsigned char TWI_state = TWI_NO_STATE;  
; 
; //Set when the TWI is in the middle of a RX transmission
; static unsigned char busyRx;
; //Set when the TWI is in the middle of a TX transmission
; static unsigned char busyTx;
; 
; /*
;  *
;  * Call this function to set up the TWI slave to its initial standby state.
;  * Remember to enable interrupts from the main application after initializing the TWI.
;  * 
;  * TWI_ownAddress : This is your 7 bit address
;  * generalCall : 0 will disable general call regnition (i.e. address 0000000)
;  * mask : This will mask (disable) the corresponding bits in the slaves address.
;  */
; void TWI_Slave_Initialise( unsigned char TWI_ownAddress, unsigned char generalCall, unsigned char mask)
; {
	.dbline 108
;   
; 	busyTx = 0;
	clr R2
	sts _busyTx,R2
	.dbline 109
; 	busyRx = 0;
	sts _busyRx,R2
	.dbline 110
;     TWI_rx_buf_index = 0;
	sts _TWI_rx_buf_index,R2
	.dbline 111
;     TWI_txDataInBuffer = 0;
	sts _TWI_txDataInBuffer,R2
	.dbline 113
;     
;     if(generalCall)
	tst R18
	breq L2
X0:
	.dbline 114
;     {
	.dbline 115
;     	TWAR = ACCEPT_GENERAL_CALL(TWI_ownAddress);  
	mov R24,R16
	lsl R24
	ori R24,1
	sts 186,R24
	.dbline 116
;     }
	xjmp L3
L2:
	.dbline 118
;     else
;     {
	.dbline 119
;     	TWAR = NO_GENERAL_CALL(TWI_ownAddress);
	mov R2,R16
	lsl R2
	sts 186,R2
	.dbline 120
;     }
L3:
	.dbline 123
;     
; 	//if you want to mask out some of your address bits
; 	TWAMR = mask<<1;
	ldd R2,y+0
	lsl R2
	sts 189,R2
	.dbline 125
; 
; 	TWDR = 0xFF; // Default content = SDA released.
	ldi R24,255
	sts 187,R24
	.dbline 127
;   
;   	TWI_state = TWI_NO_STATE ;
	ldi R24,248
	sts _TWI_state,R24
	.dbline 129
;   	
;     TWCR =	(1<<TWEN)|                         	// Enable TWI-interface
	ldi R24,148
	sts 188,R24
	.dbline 134
; 			(0<<TWIE)|(1<<TWINT)|            	// Interupt disabled
; 			(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|	// Reset the TWI module and release the SDA SCL lines.  This is in case we are already in the middle for a transaction
; 			(0<<TWWC);
;             
;     TWDR = 0xFF; // Default content = SDA released.
	ldi R24,255
	sts 187,R24
	.dbline 136
;             
;     TWCR = 	(1<<TWEN)|                         	// TWI Interface enabled.
	ldi R24,197
	sts 188,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym l mask 0 c
	.dbsym r generalCall 18 c
	.dbsym r TWI_ownAddress 16 c
	.dbend
	.dbfunc e TWI_Master_Disable _TWI_Master_Disable fV
	.even
_TWI_Master_Disable::
	.dbline -1
	.dbline 146
; 			(1<<TWIE)|(1<<TWINT)|               // Enable TWI Interupt.
; 			(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  	// Prepare to ACK next time the Slave is addressed and release the I2C lines
; 			(0<<TWWC);
; }    
; 
; /*
;  * Call this function to disable the TWI interface
;  */
; void TWI_Master_Disable(void)
; {
	.dbline 147
; 	TWCR =	(1<<TWEN)|                         	// Enable TWI-interface
	ldi R24,148
	sts 188,R24
	.dbline 151
; 			(0<<TWIE)|(1<<TWINT)|            	// Interupt disabled
; 			(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|	// Reset the TWI module and release the SDA SCL lines.  This is in case we are already in the middle for a transaction
; 			(0<<TWWC);
; 	TWCR =	(0<<TWEN);//Turn off the TWI Interface
	clr R2
	sts 188,R2
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Get_State_Info _TWI_Get_State_Info fc
	.even
_TWI_Get_State_Info::
	.dbline -1
	.dbline 163
; } 
; 
; /*
;  * Call this function to fetch the state information of the previous operation.
;  * The function will hold execution (loop) until the TWI has completed with the
;  * previous transaction or until the timer expires.
;  *
;  * Returns: The last TWI State code.
;  *			TWI_TIMEOUT_ERROR if the fdunction timed out
;  */
; unsigned char TWI_Get_State_Info( void )
; {
L6:
	.dbline 174
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//Load the timer with the max time we wish to wait for
;     
; 	while ( TWI_Transceiver_Busy() && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready for next transmission.
; 	if (!TWI_ERROR_TIMER)//If we stopped waiting due to the timer counting down, return an error code
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; 
; #else
; 	while ( TWI_Transceiver_Busy() ); // Wait until TWI is ready for next transmission.
L7:
	.dbline 174
	lds R2,188
	sbrc R2,0
	rjmp L6
X1:
	.dbline 177
; #endif
; 
; 	return ( TWI_state );// Return error state.
	lds R16,_TWI_state
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Transceiver_Update_Data _TWI_Transceiver_Update_Data fc
;      temp_TWCR -> R10
;              i -> R12
;        msgSize -> R18
;            msg -> R16,R17
	.even
_TWI_Transceiver_Update_Data::
	st -y,R10
	st -y,R12
	.dbline -1
	.dbline 192
; }
; 
; /*
;  * Call this function to set data that can be read by the master.
;  * Include a pointer to the data to be sent if a SLA+W is received
;  * The data is copied to the TWI TX buffer. 
;  * Include also how many bytes that should be sent.
;  * The function will hold execution (loop) until the TWI has completed 
;  * a current SLA+W operation then initialize the next operation and return.
;  *
;  * Returns:	TWI_NO_ERROR if the update was successful.
;  *			TWI_TIMEOUT_ERROR if the function timed out.
;  */
; unsigned char TWI_Transceiver_Update_Data( unsigned char *msg, unsigned char msgSize )
; {
L10:
	.dbline 206
;   	unsigned char i;
; 	unsigned char temp_TWCR;
;       
; #if defined(TWI_TIMER)    
;     TWI_ERROR_TIMER = TWI_TIMEOUT;//Load the timer with the max time we wish to wait for
;     
; 	while ( busyTx && (TWI_ERROR_TIMER != 0)); // Wait until TWI is ready
;     
;     if (!TWI_ERROR_TIMER)//If we stopped waiting due to the timer counting down, return an error code
;     {
;     	return TWI_TIMEOUT_ERROR;
;     }
; #else
; 	while ( busyTx ); // Wait until TWI is not in the middle of a RX.
L11:
	.dbline 206
	lds R2,_busyTx
	tst R2
	brne L10
X2:
	.dbline 210
; #endif
; 
;     //Ensure this is run as an atomic block
;     temp_TWCR = TWCR;//Save the current state of the TWCR
	lds R10,188
	.dbline 211
;     TWCR &= ~(1<<TWIE);//Disable TWI interrupts
	lds R24,188
	andi R24,254
	sts 188,R24
	.dbline 213
;   
;   	if (msgSize <= TWI_TX_BUFFER_SIZE)
	ldi R24,40
	cp R24,R18
	brlo L13
X3:
	.dbline 214
;   	{
	.dbline 215
;    	 	TWI_txDataInBuffer = msgSize;        		// Number of data to transmit.
	sts _TWI_txDataInBuffer,R18
	.dbline 216
;   	}
	xjmp L14
L13:
	.dbline 218
;   	else
;   	{
	.dbline 219
;    		TWI_txDataInBuffer = TWI_TX_BUFFER_SIZE;	//Only copy what we can
	ldi R24,40
	sts _TWI_txDataInBuffer,R24
	.dbline 220
;   	}
L14:
	.dbline 223
;   
;   
;   	for ( i = 0; i < TWI_txDataInBuffer; i++ )      // Copy data that may be transmitted if the TWI Master requests data.
	clr R12
	xjmp L18
L15:
	.dbline 224
;     {
	.dbline 225
;     	TWI_TX_BUF[ i ] = msg[ i ];
	mov R30,R12
	clr R31
	add R30,R16
	adc R31,R17
	ldd R2,z+0
	ldi R24,<_TWI_TX_BUF
	ldi R25,>_TWI_TX_BUF
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 226
;     }
L16:
	.dbline 223
	inc R12
L18:
	.dbline 223
	lds R2,_TWI_txDataInBuffer
	cp R12,R2
	brlo L15
X4:
	.dbline 229
;         
; 	//Restore the TWI Interrupts if enabled
;     TWCR = temp_TWCR;
	sts 188,R10
	.dbline 231
;     
;     return TWI_NO_ERROR;
	clr R16
	.dbline -2
L9:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r temp_TWCR 10 c
	.dbsym r i 12 c
	.dbsym r msgSize 18 c
	.dbsym r msg 16 pc
	.dbend
	.dbfunc e TWI_Get_Data_From_Transceiver _TWI_Get_Data_From_Transceiver fc
;      temp_TWCR -> R12
;              i -> R10
;        msgSize -> R18
;            msg -> R16,R17
	.even
_TWI_Get_Data_From_Transceiver::
	st -y,R10
	st -y,R12
	.dbline -1
	.dbline 242
; }
; 
; 
; /*
;  * Call this function to read any received data from the TWI RX buffer.
;  * 
;  * Returns: The number of bytes received.
;  * 			Note if the TWI is in the middle of a receive it will return 0			
;  */
; unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
; {
	.dbline 243
; 	unsigned char i = 0;
	clr R10
	.dbline 246
;     unsigned char temp_TWCR;
;  	
;     if ( (busyRx != 0) || (TWI_rx_buf_index == 0))
	lds R2,_busyRx
	tst R2
	brne L22
X5:
	lds R2,_TWI_rx_buf_index
	tst R2
	brne L20
X6:
L22:
	.dbline 247
;     {
	.dbline 248
;     	return 0;
	clr R16
	xjmp L19
L20:
	.dbline 252
;     }
; 
;     //Ensure this is run as an atomic block
;     temp_TWCR = TWCR;//Save the current state of the TWCR
	lds R12,188
	.dbline 253
;     TWCR &= ~(1<<TWIE);//Disable TWI interrupts
	lds R24,188
	andi R24,254
	sts 188,R24
	xjmp L24
L23:
	.dbline 256
; 	
;     while(TWI_rx_buf_index && i < msgSize)
;     {
	.dbline 257
;     	msg[ i ] = TWI_RX_BUF[ i ];
	ldi R24,<_TWI_RX_BUF
	ldi R25,>_TWI_RX_BUF
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	mov R30,R10
	clr R31
	add R30,R16
	adc R31,R17
	std z+0,R2
	.dbline 258
;         i++;
	inc R10
	.dbline 259
;         TWI_rx_buf_index--;
	lds R24,_TWI_rx_buf_index
	subi R24,1
	sts _TWI_rx_buf_index,R24
	.dbline 260
;     }
L24:
	.dbline 255
	lds R2,_TWI_rx_buf_index
	tst R2
	breq L26
X7:
	cp R10,R18
	brlo L23
X8:
L26:
	.dbline 262
;     
;     TWI_rx_buf_index = 0;
	clr R2
	sts _TWI_rx_buf_index,R2
	.dbline 265
;     
;     //Restore TWI register
;     TWCR  = temp_TWCR;
	sts 188,R12
	.dbline 267
;     
;     return i;                                 
	mov R16,R10
	.dbline -2
L19:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r temp_TWCR 12 c
	.dbsym r i 10 c
	.dbsym r msgSize 18 c
	.dbsym r msg 16 pc
	.dbend
	.area vector(rom, abs)
	.org 96
	jmp _TWI_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
L28:
	.blkb 2
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
	.dbfunc e TWI_Interrupt _TWI_Interrupt fV
	.dbsym s TWI_bufPtr L28 S
	.even
_TWI_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 278
; }
; 
; /*								********** Interrupt Handler **********
;  *
;  * This function is the Interrupt Service Routine (ISR), and called when the TWI interrupt is triggered;
;  * that is whenever a TWI event has occurred. This function should not be called directly from the main
;  * application.
;  */
; #pragma interrupt_handler TWI_Interrupt:iv_TWI
; void  TWI_Interrupt(void)
; {
	.dbline 281
; 	static short TWI_bufPtr;
;     
;   	TWI_state = TWSR;// Save the TWI State   
	lds R2,185
	sts _TWI_state,R2
	.dbline 283
;      
; 	switch (TWSR)
	lds R16,185
	clr R17
	cpi R16,144
	ldi R30,0
	cpc R17,R30
	brne X30
	xjmp L38
X30:
X9:
	ldi R24,144
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L45
X10:
L44:
	cpi R16,112
	ldi R30,0
	cpc R17,R30
	brne X31
	xjmp L37
X31:
X11:
	ldi R24,112
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L47
X12:
L46:
	cpi R16,0
	cpc R16,R17
	brne X32
	xjmp L43
X32:
X13:
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge X33
	xjmp L29
X33:
X14:
L48:
	cpi R16,96
	ldi R30,0
	cpc R17,R30
	brne X34
	xjmp L37
X34:
X15:
	xjmp L29
L47:
	cpi R16,128
	ldi R30,0
	cpc R17,R30
	brne X35
	xjmp L38
X35:
X16:
	cpi R16,128
	ldi R30,0
	cpc R17,R30
	brge X36
	xjmp L29
X36:
X17:
L49:
	cpi R16,136
	ldi R30,0
	cpc R17,R30
	brne X37
	xjmp L42
X37:
X18:
	xjmp L29
L45:
	cpi R16,168
	ldi R30,0
	cpc R17,R30
	breq L32
X19:
	ldi R24,168
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L51
X20:
L50:
	cpi R16,152
	ldi R30,0
	cpc R17,R30
	brne X38
	xjmp L42
X38:
X21:
	cpi R16,152
	ldi R30,0
	cpc R17,R30
	brge X39
	xjmp L29
X39:
X22:
L52:
	cpi R16,160
	ldi R30,0
	cpc R17,R30
	brne X40
	xjmp L41
X40:
X23:
	xjmp L29
L51:
	cpi R16,192
	ldi R30,0
	cpc R17,R30
	brne X41
	xjmp L36
X41:
X24:
	ldi R24,192
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L54
X25:
L53:
	cpi R16,184
	ldi R30,0
	cpc R17,R30
	breq L33
X26:
	xjmp L29
L54:
	cpi R16,200
	ldi R30,0
	cpc R17,R30
	breq L36
X27:
	xjmp L29
L32:
	.dbline 287
; 	{
; 		case TWI_STX_ADR_ACK: // Own SLA+R has been received; ACK has been returned
; //    	case TWI_STX_ADR_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
; 			TWI_bufPtr = 0; // Set buffer pointer to first data location
	clr R2
	clr R3
	sts L28+1,R3
	sts L28,R2
	.dbline 288
; 			busyTx = 1; //This flag says that data is currently being read by the master 
	ldi R24,1
	sts _busyTx,R24
L33:
	.dbline 292
; 		
;         case TWI_STX_DATA_ACK: // Data byte in TWDR has been transmitted; ACK has been received
;  
; 	  		TWDR = TWI_TX_BUF[TWI_bufPtr++];
	lds R2,L28
	lds R3,L28+1
	movw R24,R2
	adiw R24,1
	sts L28+1,R25
	sts L28,R24
	ldi R24,<_TWI_TX_BUF
	ldi R25,>_TWI_TX_BUF
	movw R30,R2
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 187,R2
	.dbline 294
;         
; 			if (TWI_bufPtr < TWI_txDataInBuffer)//ensure we still have data in our buffer
	lds R2,_TWI_txDataInBuffer
	clr R3
	lds R4,L28
	lds R5,L28+1
	cp R4,R2
	cpc R5,R3
	brge L34
X28:
	.dbline 295
; 			{
	.dbline 296
; 				TWCR =	(1<<TWEN)|                         // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 300
;              			(1<<TWIE)|(1<<TWINT)|              // Enable TWI Interupt and clear the flag to the send byte
;              			(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|   // Expect an ACK for the byte 
;              			(0<<TWWC);
; 			}
	xjmp L30
L34:
	.dbline 302
; 			else
; 			{
	.dbline 303
; 				TWCR =	(1<<TWEN)|                         // TWI Interface enabled
	ldi R24,133
	sts 188,R24
	.dbline 307
;           		   		(1<<TWIE)|(1<<TWINT)|              // Enable TWI Interupt and clear the flag to the send byte
;              			(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|   // Expect a NACK for the byte 
;              			(0<<TWWC);
; 			}
	.dbline 309
;   
;       		break;
	xjmp L30
L36:
	.dbline 316
; 	  
; 		case TWI_STX_DATA_NACK: // Data byte in TWDR has been transmitted; NACK has been received. 
;                             // I.e. the end of the transmission.
; 		case TWI_STX_DATA_ACK_LAST_BYTE: // Last data byte in TWDR has been transmitted (TWEA = 0); ACK has been received
; 
; 									 
; 			busyTx = 0;	// We are no longer being read by the master						 
	clr R2
	sts _busyTx,R2
	.dbline 318
; 									 
; 			TWCR =	(1<<TWEN)|                          // Enable TWI-interface
	ldi R24,197
	sts 188,R24
	.dbline 322
;           		   	(1<<TWIE)|(1<<TWINT)|               // Enable Interupt and clear the interrupt
;            		  	(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|    // Acknowledge any new requests.
;            		  	(0<<TWWC);                          
;       		break;
	xjmp L30
L37:
	.dbline 332
; 	  
; 	  
; 		case TWI_SRX_GEN_ACK:            // General call address has been received; ACK has been returned
; //    case TWI_SRX_GEN_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
; 
;     	case TWI_SRX_ADR_ACK:            // Own SLA+W has been received ACK has been returned
; //    case TWI_SRX_ADR_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned    
;                                                         // Dont need to clear TWI_S_statusRegister.generalAddressCall due to that it is the default state.
;      
; 			busyRx = 1;	// Flag to show that the master is writing to us
	ldi R24,1
	sts _busyRx,R24
	.dbline 333
; 	 	  	TWI_rx_buf_index = 0;
	clr R2
	sts _TWI_rx_buf_index,R2
	.dbline 335
;                                                          
; 			TWCR =	(1<<TWEN)|                           // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 339
;        		      	(1<<TWIE)|(1<<TWINT)|                // Enable TWI Interupt and clear the flag to send byte
;           		   	(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|     // ACK data
;         		     (0<<TWWC);     
;       		break;
	xjmp L30
L38:
	.dbline 344
;             
; 		case TWI_SRX_ADR_DATA_ACK:       // Previously addressed with own SLA+W; data has been received; ACK has been returned
;     	case TWI_SRX_GEN_DATA_ACK:       // Previously addressed with general call; data has been received; ACK has been returned
;             
;             TWI_RX_BUF[ TWI_rx_buf_index++] = TWDR;
	lds R2,_TWI_rx_buf_index
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts _TWI_rx_buf_index,R24
	ldi R24,<_TWI_RX_BUF
	ldi R25,>_TWI_RX_BUF
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,187
	std z+0,R2
	.dbline 346
; 	  		//Ensure that our buffer has enough room for more data
; 			if ( TWI_rx_buf_index < TWI_RX_BUFFER_SIZE)//TWI_txDataInBuffer
	lds R24,_TWI_rx_buf_index
	cpi R24,40
	brsh L39
X29:
	.dbline 347
; 			{
	.dbline 348
; 				TWCR =	(1<<TWEN)|                             // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 352
;              			(1<<TWIE)|(1<<TWINT)|                  // Enable TWI Interupt and clear the flag
;              			(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|       // Send ACK after next reception
;              			(0<<TWWC);  
; 			}
	xjmp L30
L39:
	.dbline 354
; 			else
; 			{
	.dbline 355
; 				TWCR =	(1<<TWEN)|                             // TWI Interface enabled
	ldi R24,133
	sts 188,R24
	.dbline 359
;              			(1<<TWIE)|(1<<TWINT)|                  // Enable TWI Interupt and clear the flag
;              			(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|       // Send NACL after next reception
;              			(0<<TWWC);  
; 			}                      
	.dbline 361
;  
;       		break;
	xjmp L30
L41:
	.dbline 365
;     
;     	case TWI_SRX_STOP_RESTART:       // A STOP condition or repeated START condition has been received while still addressed as Slave    
; 		
;         	busyRx = 0;//we are finished reading in data
	clr R2
	sts _busyRx,R2
	.dbline 368
; 	 
; 	                                     
;       		TWCR = 	(1<<TWEN)|                              // Enable TWI-interface and release TWI pins
	ldi R24,197
	sts 188,R24
	.dbline 372
;              		(1<<TWIE)|(1<<TWINT)|                   // Enable Interupt
;              		(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|        // Acknowledge any new requests.
;              		(0<<TWWC); 
; 	  		break;
	xjmp L30
L42:
	.dbline 377
; 	            
;     	case TWI_SRX_ADR_DATA_NACK:      // Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
;     	case TWI_SRX_GEN_DATA_NACK:      // Previously addressed with general call; data has been received; NOT ACK has been returned
;     	
;        		busyRx = 0;//we are finished reading in data
	clr R2
	sts _busyRx,R2
	.dbline 379
;         
;         	TWI_RX_BUF[ TWI_rx_buf_index++] = TWDR;//read in the last byte we can receive
	lds R16,_TWI_rx_buf_index
	clr R17
	mov R24,R16
	subi R24,255    ; addi 1
	sts _TWI_rx_buf_index,R24
	ldi R24,<_TWI_RX_BUF
	ldi R25,>_TWI_RX_BUF
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,187
	std z+0,R2
	.dbline 381
;    		
;         	TWCR = 	(1<<TWEN)|                              // Enable TWI-interface and release TWI pins
	ldi R24,197
	sts 188,R24
	.dbline 385
;              		(1<<TWIE)|(1<<TWINT)|                   // Enable Interupt
;              		(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|        // Acknowledge any new requests.
;              		(0<<TWWC); 
; 			break;
	xjmp L30
L43:
L29:
	.dbline 392
;         
;     //    case TWI_NO_STATE              // No relevant state information available; TWINT = 0
;     	case TWI_BUS_ERROR:         // Bus error due to an illegal START or STOP condition
;     	default:     
;       		
;       		//reset all my indexs
;       		busyRx = 0;
	clr R2
	sts _busyRx,R2
	.dbline 393
;       		busyTx = 0;
	sts _busyTx,R2
	.dbline 394
;       		TWI_rx_buf_index = 0;
	sts _TWI_rx_buf_index,R2
	.dbline 402
;             
; #if defined(DEBUG)     
;      		uart0_puts ("\nError ");
; 	  		Print_Int(TWI_state,text,16);
; 	  		uart0_puts (text);
; 	  		uart0_puts ("\n");
; #endif	  	 
; 	  		TWCR = 	(1<<TWEN)|                                 // Enable TWI-interface and release TWI pins
	ldi R24,213
	sts 188,R24
	.dbline 407
;              		(1<<TWIE)|(1<<TWINT)|                      // Ensable Interupt
;              		(1<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|           // Release the SDA SCL lines
;              		(0<<TWWC);
;              
;       		TWCR = 	(1<<TWEN)|                                 // Enable TWI-interface and release TWI pins
	ldi R24,197
	sts 188,R24
	.dbline 411
;              		(1<<TWIE)|(1<<TWINT)|                      // Ensable Interupt
;              		(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|           // Prepare to ACK next time the slave is addressed
;              		(0<<TWWC);                                 //
; 	}
L30:
	.dbline -2
L27:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\SmartLCD\TWI_slave.c
_busyTx:
	.blkb 1
	.dbsym s busyTx _busyTx c
_busyRx:
	.blkb 1
	.dbsym s busyRx _busyRx c
_TWI_rx_buf_index:
	.blkb 1
	.dbsym s TWI_rx_buf_index _TWI_rx_buf_index c
_TWI_RX_BUF:
	.blkb 40
	.dbsym s TWI_RX_BUF _TWI_RX_BUF A[40:40]c
_TWI_TX_BUF:
	.blkb 40
	.dbsym s TWI_TX_BUF _TWI_TX_BUF A[40:40]c
; }
